// fonted.cpp		ver.0.02
//copyright 2005-2012 Beer[Tsutsumi Hiroyuki]

#include	"fonted.h"

#define	VER		"ver.0.02"
#define	DATE	"2012. 1. 1"

int	main()
{
	fonted	app;
	app.Run();
	return(0);
}

uchar* malloc32(int bytes)
{
	while(bytes&3)bytes++;
	uchar	*mem=new uchar[bytes];
	memset(mem,0,bytes);
	return(mem);
}
//------------------------------------------------
fonted::fonted():BApplication("application/x-vnd.Beer-fonted")
{
#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("fonted");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	BRect	frame;
	frame.Set(100,100,499,399);
	w=new fontedwindow(frame);
	fp=NULL;		//file-panel
}

void fonted::RefsReceived(BMessage *msg)
{
	entry_ref	eref;
	msg->FindRef("refs",&eref);
	load(eref);
	fp=NULL;		//file-panel
}

void fonted::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					if(!load(eref))break;
				}
			}
		}break;
		case B_SAVE_REQUESTED:{
			if(canvas!=BRect(0,0,0,0)){
				entry_ref	dir;
				const char	*name;
				msg->FindRef("directory",&dir);
				msg->FindString("name",&name);
				save(dir,name);
			}
			fp=NULL;		//file-panel
		}break;
		case B_CANCEL:{
			fp=NULL;		//file-panel
		}break;
		case 'fine':{	//file-new > config start
			start();
		}break;
		case 'cfge':{	//config end > edit start
			start2();
		}break;
		default:{
			BApplication::MessageReceived(msg);
		}break;
	}
}

void fonted::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"fonted "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 

void fonted::clear()
{
	w->Lock();
	if(ettf){
		w->v->clr();
		delete ettf;ettf=NULL;
	}
	if(w->iniv){
		w->v->RemoveChild(w->iniv);
		delete w->iniv;w->iniv=NULL;
	}
	w->Unlock();
}

void fonted::start()
{
	clear();
	ettf=new ttf();
	w->iniv=new initview(BRect(0,0,0,0));
	w->v->AddChild(w->iniv);
	w->v->Window()->Zoom();
}

void fonted::start2()
{
	ettf->init();
	//delete iniv
	w->Lock();
	w->v->RemoveChild(w->iniv);
	delete w->iniv;w->iniv=NULL;
	w->Unlock();
	//set new-canvas
	canvasok=false;
	BMessage	mes('init');
	BRect	b=ettf->bounds();
	BRect	r(0,0,b.right-b.left,b.top-b.bottom);
	mes.AddRect("bounds",r);
	BMessenger(w->v).SendMessage(&mes);
	while(!canvasok)snooze(1);
}

int fonted::load(entry_ref &eref)
{
printf("fonted:load\n");
	clear();
	BFile	f(&eref,B_READ_ONLY);
	ettf=new ttf();
	if(ettf->load(f))return(1);
	//set new-canvas
	canvasok=false;
	BMessage	mes('init');
	BRect	b=ettf->bounds();
	BRect	r(0,0,b.right-b.left,b.top-b.bottom);
	mes.AddRect("bounds",r);
	BMessenger(w->v).SendMessage(&mes);
	while(!canvasok)snooze(1);
	return(0);
}

int fonted::save(entry_ref &dir,const char *name)
{
printf("fonted:save\n");
	BFile	f;
	BDirectory(&dir).CreateFile(name,&f,false);
	if(ettf->save(f))return(1);

	//set mime
	BAppFileInfo	fi(&f);
	fi.SetType("application/x-truetype");
	return(0);
}
//------------------------------------------------
fontedwindow::fontedwindow(BRect frame):BWindow(frame,"fonted "VER,B_DOCUMENT_WINDOW,0)
{
	iniv=NULL;
	scv=NULL;
	iv=NULL;
	sw=512;sh=512;

	BRect	viewframe,sbvframe,sbhframe,selectframe;
	selectframe.Set(0,0,Bounds().right,32);
	selectframe.OffsetTo(0,20);				//menu=20
	sv=new selectview(selectframe);
	AddChild(sv);

	viewframe.Set(0,0,Bounds().right-B_V_SCROLL_BAR_WIDTH,Bounds().bottom-B_H_SCROLL_BAR_HEIGHT-20-32);
	viewframe.OffsetTo(0,selectframe.bottom+1);
	v=new fontedview(viewframe);
	AddChild(v);
	setupmenus();

	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height());
	sbvframe.OffsetTo(viewframe.right+1,viewframe.top);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	sbhframe.Set(0,0,viewframe.Width(),B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(viewframe.left,viewframe.bottom+1);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);

	FrameResized(frame.Width(),frame.Height());
	Show();
	SetPulseRate(100000);
}

bool fontedwindow::QuitRequested()
{
	RemoveChild(v);

	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);
	return(true);
}

void fontedwindow::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	int	w,h;
	w=561+(int)B_V_SCROLL_BAR_WIDTH;			//+scrollbar
	h=511+20+33+(int)B_H_SCROLL_BAR_HEIGHT;	//+menu+selectview+scrollbar
	ResizeTo(w,h);
}

void fontedwindow::FrameResized(float width,float height)
{
	updatescrollbar();
}

void fontedwindow::DispatchMessage(BMessage *msg,BHandler *handler)
{
	while(1){
		if(handler!=iv)break;
		if((msg->what!=B_MOUSE_DOWN)&&(msg->what!=B_MOUSE_UP)&&(msg->what!=B_MOUSE_MOVED))break;
		float	f1,f2;
		int32	l;
		int64	ll;
		BPoint	p;
		if(!msg->FindInt32("be:cursor_needed",&l))break;	//anti-noise
		if(!msg->FindInt32("_msg_what_",&l))break;			//drag-now
//msg->PrintToStream();
		inp.flags=0;
		if((!msg->FindFloat("be:tablet_x",&f1))&&(!msg->FindFloat("be:tablet_y",&f2))){inp.x=f1;inp.y=f2;inp.flags|=TABLET_XY;}
		if((!msg->FindFloat("be:tablet_tilt_x",&f1))&&(!msg->FindFloat("be:tablet_tilt_y",&f2))){inp.tilt_x=f1;inp.tilt_y=f2;inp.flags|=TABLET_TILT_XY;}
		if(!msg->FindFloat("be:tablet_pressure",&f1)){inp.pressure=f1;inp.flags|=TABLET_PRESSURE;}
		if(!msg->FindInt32("be:tablet_eraser",&l)){inp.eraser=l;inp.flags|=TABLET_ERASER;}
		if(!msg->FindInt32("modifiers",&l)){inp.modifiers=l;inp.flags|=MODIFIERS;}
		if(!msg->FindInt32("buttons",&l)){inp.buttons=l;inp.flags|=BUTTONS;}
		if(!msg->FindInt64("when",&ll)){inp.when=ll;inp.flags|=WHEN;}
		if(!msg->FindPoint("be:view_where",&p)){inp.where=p;inp.flags|=WHERE;}
		if(!msg->FindInt32("be:transit",&l)){inp.transit=l;inp.flags|=TRANSIT;}
		break;
	}
	BWindow::DispatchMessage(msg,handler);
}

void fontedwindow::settarget(BRect limit,BView *scrollview,BView *inputview,float scrw,float scrh)
{
	if(scrollview){
		scv=scrollview;							//for scroll

		float	xmin,xmax,ymin,ymax;
		xmin=limit.left;
		xmax=limit.right+B_V_SCROLL_BAR_WIDTH;
		ymin=limit.top;
		ymax=limit.bottom+B_H_SCROLL_BAR_HEIGHT+20+33;	//+menu+selectview
		SetSizeLimits(xmin,xmax,ymin,ymax);
		SetZoomLimits(xmax,ymax);

		sbv->SetValue(0);
		sbh->SetValue(0);
		updatescrollbar();
		sbv->SetTarget(scv);
		sbh->SetTarget(scv);
	}

	if(scrw&&scrh){
		sw=scrw;sh=scrh;
	}else{
		sw=scv->Bounds().Width()+1;
		sh=scv->Bounds().Height()+1;
	}

	updatescrollbar();

	if(inputview)iv=inputview;					//for dispatch(mouse)
}

void fontedwindow::updatescrollbar()
{
	if(scv){
		float	rv,rh;
		rv=sh-(scv->Bounds().Height()+1)-1;
		rh=sw-(scv->Bounds().Width()+1)-1;
		if(rv<0)rv=0;
		if(rh<0)rh=0;
		sbv->SetRange(0,rv);
		sbh->SetRange(0,rh);
		sbv->SetProportion((scv->Bounds().Height()+1)/sh);
		sbh->SetProportion((scv->Bounds().Width()+1)/sw);
		sbv->SetSteps(5,scv->Bounds().Height());
		sbh->SetSteps(5,scv->Bounds().Width());
	}
}

void fontedwindow::setupmenus()
{
	BMenu		*m;
	BMenuItem	*mi;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("New"),new BMessage('fine'));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Save as"),new BMessage('finw'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}

void fontedwindow::markmenu(const char *menu,const char *item)
{
	if(mb==NULL)return;
	int	c=mb->CountItems();
	for(int i=0;i<c;i++){
		BMenu	*m=mb->SubmenuAt(i);
		if(strcmp(m->Name(),menu))continue;
		int	ic=m->CountItems();
		for(int j=0;j<ic;j++){
			BMenuItem	*mi=m->ItemAt(j);
			if(*item==0)mi->SetMarked(false);
			if(strcmp(mi->Label(),item))continue;
			mi->SetMarked(true);
		}
	}
}
//------------------------------------------------
selectview::selectview(BRect frame):BView(frame,"selector",B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW)
{
	bm=NULL;
	tbls=0;
	no=-1;

	cnt_cp=0;
	sh_cp=new shape*[512];
}

selectview::~selectview()
{
	if(bm)delete bm;
}

void selectview::AttachedToWindow()
{
	SetViewColor((uchar)(SELECTVIEWCOLOR>>16),(uchar)(SELECTVIEWCOLOR>>8),(uchar)SELECTVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(BRect(0,0,561,32),B_RGB_32_BIT,true);
	redraw();
}

void selectview::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
}

void selectview::MouseDown(BPoint pt)
{
	if(pt.y>=20){
		int	n=(pt.x-10)/30;
		if(n<tbls){
			BMessage	*mes;
			mes=new BMessage('tsel');
			mes->AddInt32("table",table[n]);
			BMessenger(((fontedwindow*)Window())->v).SendMessage(mes);
		}
	}
}

void selectview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'tsel':{
			int32	i32;
			if(!msg->FindInt32("table",&i32)){
				for(int i=0;i<tbls;i++)if(table[i]==(uint32)i32){
					no=i;
					redraw();
					break;
				}
			}
		}break;

		case 'tset':{
			int32	i32;
			no=-1;
			tbls=0;
			while(!msg->FindInt32("table",tbls,&i32))table[tbls++]=(uint32)i32;
			redraw();
		}break;

		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void selectview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(SELECTVIEWCOLOR);

	BView *wv=new BView(bm->Bounds(),"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
	bm->Lock();
	bm->AddChild(wv);
	for(int i=0;i<tbls;i++){
		int	x=i*30+10;
		int	y=20;
		char	s[8];
		sprintf(s,"%c%c%c%c",table[i]>>24,table[i]>>16,table[i]>>8,table[i]);
		if(i==no){	//select
			wv->SetHighColor(255,0,0);
			wv->DrawString(s,BPoint(x,y+10));
		}else{		//not select
			wv->SetHighColor(0,0,0);
			wv->DrawString(s,BPoint(x,y+10));
		}
	}
	wv->Sync();
	bm->RemoveChild(wv);
	bm->Unlock();

	Draw(Bounds());
}
//------------------------------------------------
fontedview::fontedview(BRect frame):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	canvas=BRect(0,0,0,0);
}

fontedview::~fontedview()
{
}

void fontedview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
}

void fontedview::Draw(BRect rect)
{
	SetFontSize(30);
	DrawString("fonted",BPoint(45,50));
	SetFontSize(20);
	DrawString(VER,BPoint(75,80));
}

void fontedview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{	//'DATA'(drop from external)
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){		//file
				BMessenger(be_app).SendMessage(msg);	//be_app->PostMessage(msg,be_app);
				break;
			}
		}break;
		case 'init':{
			Window()->Zoom();
			init();
		}break;
		case 'tsel':{	//select table view
			uint32	tbl=0;
			int32	i32;
			if(!msg->FindInt32("table",&i32))tbl=(uint32)i32;
			
			for(int i=0;;i++){
				BView	*cv=ChildAt(i);
				if(cv==NULL)break;
				if(strcmp(cv->Name(),"table"))continue;
				ttf_table	*tv=(ttf_table*)cv;

				Window()->Zoom();
				if(tv->tbl_name==tbl){		//select
					if(tbl=='glyf'){
						ttf_glyf	*gv=(ttf_glyf*)tv;
						float	sc=gv->ev->getscale();
						gv->ev->chgscale(1);
						gv->show(true);
						((fontedwindow*)Window())->settarget(BRect(400,300,561,511),gv->ev,gv->ev);
						gv->ev->chgscale(sc);
					}else{
						tv->show(true);
						((fontedwindow*)Window())->settarget(BRect(400,300,561,511),tv,NULL);
					}
				}else{						//not select
					tv->show(false);
				}
			}
			if(tbl){
				BMessage	*mes=new BMessage('tsel');
				mes->AddInt32("table",tbl);
				BMessenger(((fontedwindow*)Window())->sv).SendMessage(mes);
			}
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'finw':{
			if(fp==NULL){
				fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void fontedview::init()
{
	ettf->set_view(this);

	BMessage	*mes;

	mes=new BMessage('init');
	BRect	b=ettf->bounds();
	BRect	r(0,0,b.right-b.left,b.top-b.bottom);
	mes->AddRect("bounds",r);
	BMessenger(ettf->glyf->ev).SendMessage(mes);//Window()->PostMessage(mes,ettf->glyf->ev);

	mes=new BMessage('tset');
	int		count=32;
	uint32	*name=new uint32[count];
	ettf->get_tables(&count,name);
	for(int i=0;i<count;i++)mes->AddInt32("table",name[i]);
	delete name;
	BMessenger(((fontedwindow*)Window())->sv).SendMessage(mes);
}

void fontedview::clr()
{
	BMessenger(((fontedwindow*)Window())->sv).SendMessage('tset');
	Window()->Zoom();
	((fontedwindow*)Window())->settarget(BRect(400,300,561,511),this,NULL);

	ettf->reset_view(this);
}
//------------------------------------------------
shape::shape(int c)
{
	pts=c;
	pt=new BPoint[1024];
	pf=new char[1024];
	sel_pt=0;
	addf=false;
}

shape::~shape()
{
#if	__INTEL__
	delete pt;
#endif
	delete pf;
}

bool shape::get(const int &no,BPoint &p,char &f)
{
	if(no>=pts)return(false);
	p=pt[no];
	f=pf[no];
	return(true);
}

void shape::set(const int &no,const BPoint &p,const char &f)
{
	pt[no]=p;
	pf[no]=f;
}

shape* shape::copy()
{
	shape	*neo=new shape(pts);
	for(int i=0;i<pts;i++)neo->set(i,pt[i],pf[i]);
	neo->sel_pt=sel_pt;
	neo->rec=rec;
	return(neo);
}

int shape::select_chk(const BPoint &p,float pz)
{
	int	spt=0;
	for(int i=0;i<pts;i++){
		BRect	rp(pt[i].x-pz,pt[i].y-pz,pt[i].x+pz,pt[i].y+pz);
		if(rp.Contains(p))spt=i+1;
	}
	if(spt==0){
		if(rec.Contains(p))spt=-1;
	}
	if(spt)sel_pt=spt;
	addf=(spt>0);
	return(spt);
}

int shape::select_chk(const BRect &r)
{
	int	spt=0;
	if(r.Contains(rec)||r.Intersects(rec))spt=-1;
	if(spt)sel_pt=spt;
	addf=(spt>0);
	return(spt);
}

void shape::move(const BPoint &d)
{
	if(sel_pt==0)return;
	if(sel_pt<0){
		for(int i=0;i<pts;i++)pt[i]+=d;
	}else{
		pt[sel_pt-1]+=d;
	}
	ctrlp2form();
}

void shape::inspoint(const BPoint &d)
{
	if(!addf)return;
	BPoint	p=d+pt[sel_pt-1];
	char	f=pf[sel_pt-1];
	float	d1,d2;
	d1=0;d2=0;
	if(sel_pt!=1){
		d1+=(p.x-pt[sel_pt-2].x)*(p.x-pt[sel_pt-2].x)+(p.y-pt[sel_pt-2].y)*(p.y-pt[sel_pt-2].y);
		d2+=(pt[sel_pt-2].x-pt[sel_pt-1].x)*(pt[sel_pt-2].x-pt[sel_pt-1].x)+(pt[sel_pt-2].y-pt[sel_pt-1].y)*(pt[sel_pt-2].y-pt[sel_pt-1].y);
	}else{
		d1+=(p.x-pt[pts-1].x)*(p.x-pt[pts-1].x)+(p.y-pt[pts-1].y)*(p.y-pt[pts-1].y);
		d2+=(pt[pts-1].x-pt[0].x)*(pt[pts-1].x-pt[0].x)+(pt[pts-1].y-pt[0].y)*(pt[pts-1].y-pt[0].y);
	}
	if(sel_pt!=pts){
		d1+=(pt[sel_pt].x-pt[sel_pt-1].x)*(pt[sel_pt].x-pt[sel_pt-1].x)+(pt[sel_pt].y-pt[sel_pt-1].y)*(pt[sel_pt].y-pt[sel_pt-1].y);
		d2+=(p.x-pt[sel_pt].x)*(p.x-pt[sel_pt].x)+(p.y-pt[sel_pt].y)*(p.y-pt[sel_pt].y);
	}else{
		d1+=(pt[0].x-pt[pts-1].x)*(pt[0].x-pt[pts-1].x)+(pt[0].y-pt[pts-1].y)*(pt[0].y-pt[pts-1].y);
		d2+=(p.x-pt[0].x)*(p.x-pt[0].x)+(p.y-pt[0].y)*(p.y-pt[0].y);
	}
	if(d1>d2)sel_pt++;
	for(int i=pts;i>=sel_pt;i--){pt[i]=pt[i-1];pf[i]=pf[i-1];}
	pt[sel_pt-1]=p;pf[sel_pt-1]=f;
	pts++;
	ctrlp2form();
	addf=false;
}

bool shape::delpoint()
{
	bool	f=(--pts<3);
	if(!f){
		for(int i=sel_pt-1;i<pts;i++){pt[i]=pt[i+1];pf[i]=pf[i+1];}
		ctrlp2form();
	}
	return(f);
}

void shape::tglpoint()
{
	if(sel_pt<0)for(int i=0;i<pts;i++)pf[i]^=1;
	if(sel_pt>0)pf[sel_pt-1]^=1;
}

void shape::reverse()
{
	if(sel_pt<0){
		for(int i=0;i<pts/2;i++){
			int	j=pts-i-1;
			BPoint	tp=pt[i];pt[i]=pt[j];pt[j]=tp;
			char	tf=pf[i];pf[i]=pf[j];pf[j]=tf;
		}
	}
}

void shape::draw(BView *v,uint32 col)
{
v->PushState();
	if(col){
		v->SetHighColor(col>>16,col>>8,col);
	}else{
		if(ispositive())v->SetHighColor(255,255,255);else v->SetHighColor(100,100,255);
	}
	
	BShape	bs;
	BPoint	q[4];
	if(pf[0]==0){
		q[3]=pt[0];
	}else if(pf[pts-1]==0){
		q[3]=pt[pts-1];
	}else{
		q[3]=BPoint((pt[pts-1].x+pt[0].x)/2,(pt[pts-1].y+pt[0].y)/2);
	}
	bs.MoveTo(q[3]);
	for(int i=0;i<pts;i++){
		q[0]=q[3];
		int	j=(i<pts-1)?i+1:0;
		if(pf[i]==0){
			if(pf[j]==0){
				q[3]=pt[j];
				bs.LineTo(q[3]);
			}
		}else{
			if(pf[j]==0){
				q[3]=pt[j];
			}else{
				q[3]=BPoint((pt[i].x+pt[j].x)/2,(pt[i].y+pt[j].y)/2);
			}
			q[1]=BPoint((q[0].x+pt[i].x*2)/3,(q[0].y+pt[i].y*2)/3);
			q[2]=BPoint((q[3].x+pt[i].x*2)/3,(q[3].y+pt[i].y*2)/3);
			bs.BezierTo(q+1);
		}
	}
	v->StrokeShape(&bs);
v->PopState();
}

void shape::drawframe(BView *v,float pz)
{
	if(sel_pt==0)return;
	v->SetDrawingMode(B_OP_INVERT);
	for(int i=0;i<pts;i++){
		BPoint	p(pt[i].x,pt[i].y);
		if(pf[i]==0){
			v->FillRect(BRect(p.x-pz,p.y-pz,p.x+pz,p.y+pz));
		}else{
			v->FillEllipse(BRect(p.x-pz,p.y-pz,p.x+pz,p.y+pz));
		}
	}
	v->SetDrawingMode(B_OP_COPY);
}

void shape::ctrlp2form()
{
	float	l,r,t,b;
	l=r=pt[0].x;	t=b=pt[0].y;
	for(int i=1;i<pts;i++){
		if(l>pt[i].x)l=pt[i].x;
		if(r<pt[i].x)r=pt[i].x;
		if(t>pt[i].y)t=pt[i].y;
		if(b<pt[i].y)b=pt[i].y;
	}
	rec=BRect(l,t,r,b);
}

void shape::trans(const BRect &from,const BRect &to)
{
	float	fw,fh,tw,th;
	fw=from.Width();	fw=(fw>=0)?fw+1:fw-1;
	fh=from.Height();	fh=(fh>=0)?fh+1:fh-1;
	tw=to.Width();		tw=(tw>=0)?tw+1:tw-1;
	th=to.Height();		th=(th>=0)?th+1:th-1;
	float	kx,ky,dx,dy;
	kx=tw/fw;
	ky=th/fh;
	dx=to.left-from.left*kx;
	dy=to.top-from.top*ky;
	for(int i=0;i<pts;i++){
		pt[i].x=pt[i].x*kx+dx;
		pt[i].y=pt[i].y*ky+dy;
	}
	ctrlp2form();
}

shape* shape::transcopy(int16 ox,int16 oy,int16 sc00,int16 sc01,int16 sc10,int16 sc11)
{
	float	k00,k01,k10,k11;
	k00=sc00/0x4000;
	k01=sc01/0x4000;
	k10=sc10/0x4000;
	k11=sc11/0x4000;
	shape	*neo=new shape(pts);
	neo->sel_pt=0;
	for(int i=0;i<pts;i++){
		float	x,y;
		x=pt[i].x*k00+pt[i].y*k01+ox;
		y=pt[i].x*k10+pt[i].y*k11+oy;
		neo->set(i,BPoint(x,y),pf[i]);
	}
	return(neo);
}

bool shape::ispositive()
{
	bool	f=true;
	int		tp=0;
	float	top=pt[0].y;
	for(int i=1;i<pts;i++)if(top>pt[i].y)top=pt[tp=i].y;
	float	dx1=pt[tp].x-pt[(tp+pts-1)%pts].x;
	float	dx2=pt[(tp+1)%pts].x-pt[tp].x;
	float	dy1=pt[tp].y-pt[(tp+pts-1)%pts].y;
	float	dy2=pt[(tp+1)%pts].y-pt[tp].y;
	if((dx1>=0)&&(dx2>=0)){
		f=true;
	}else if((dx1<=0)&&(dx2<=0)){
		f=false;
	}else{
		f=((dy1/dx1)>(dy2/dx2));
	}
	return(f);
}
//------------------------------------------------
glyph::glyph(uint16 no)
{
	gno=no;
	dep=0;
	gc=0;
	cnt=0;
	sh=new shape*[512];
	gl=new glyph*[MAX_COMPONENT];
	ox=new int16[MAX_COMPONENT];
	oy=new int16[MAX_COMPONENT];
	sc00=new uint16[MAX_COMPONENT];
	sc01=new uint16[MAX_COMPONENT];
	sc10=new uint16[MAX_COMPONENT];
	sc11=new uint16[MAX_COMPONENT];
}

glyph::~glyph()
{
	while(gc){delete gl[--gc];delete sh[cnt+gc];}
	while(cnt)delete sh[--cnt];
	delete sh;
	delete gl;
	delete ox;
	delete oy;
	delete sc00;
	delete sc01;
	delete sc10;
	delete sc11;
}

void glyph::add_shape(shape *s)
{
	sh[cnt++]=s;
}

void glyph::del_sel()
{
	int	c=0;
	for(int i=0;i<cnt;i++){
		if((sh[i]->sel_pt>0)&&(sh[i]->delpoint())){
			delete sh[i];
		}else if(sh[i]->sel_pt<0){
			delete sh[i];
		}else{
			sh[c++]=sh[i];
		}
	}
	cnt=c;
}

void glyph::tgl_sel()
{
	for(int i=0;i<cnt;i++)sh[i]->tglpoint();
}

void glyph::rev_sel()
{
	for(int i=0;i<cnt;i++)sh[i]->reverse();
}

void glyph::copy_sel(const BPoint &d)
{
	int	c=cnt;
	for(int i=0;i<c;i++){
		if(sh[i]->sel_pt<0){		//copy
			sh[cnt++]=sh[i]->copy();
			sh[i]->sel_pt=0;
		}else if(sh[i]->sel_pt>0){	//add point(for poligon,round)
			sh[i]->inspoint(d);
		}
	}
}

void glyph::move_sel(const BPoint &d)
{
	if(gc==0){
		for(int i=0;i<cnt;i++){			//move
			if(sh[i]->sel_pt==0)continue;
			sh[i]->move(d);
		}
	}else{
		for(int i=cnt;i<cnt+gc;i++){
			if(sh[i]->sel_pt==0)continue;
			//update offset
			ox[i-cnt]+=d.x;oy[i-cnt]-=d.y;
			sh[i]->move(d);
		}
	}
}

void glyph::copy()
{
printf("copy\n");
	while(cnt_cp)delete sh_cp[--cnt_cp];

	for(int i=0;i<cnt;i++){
		if(sh[i]->sel_pt<0){
			sh_cp[cnt_cp]=sh[i]->copy();
			sh_cp[cnt_cp++]->sel_pt=0;
		}
	}
}

void glyph::paste()
{
printf("paste\n");
	for(int i=0;i<cnt_cp;i++){
			sh[cnt]=sh_cp[i]->copy();
			sh[cnt++]->sel_pt=0;
	}
}

void glyph::sel_check()
{
	if(gc==0){
		for(int i=0;i<cnt;i++)if(sh[i]->sel_pt>0)sh[i]->sel_pt=-1;
	}else{
		for(int i=cnt;i<cnt+gc;i++)if(sh[i]->sel_pt>0)sh[i]->sel_pt=-1;
	}
}

uchar glyph::sel_check(const BPoint &p,float pz)
{
	uchar	scf=0;
	if(gc==0){
		for(int i=0;i<cnt;i++){
			if(sh[i]->sel_pt==0)continue;
			int	scp=sh[i]->select_chk(p,pz);
			if(scp<0)scf|=1;
			if(scp>0)scf|=2;
		}
	}else{
		for(int i=cnt;i<cnt+gc;i++){
			if(sh[i]->sel_pt==0)continue;
			int	scp=sh[i]->select_chk(p,pz);
			if(scp)scf=1;
		}
	}
	return(scf);
}

bool glyph::sel_check(const BRect &r)
{
	bool	f=false;
	if(gc==0){
		for(int i=0;i<cnt;i++){
			if(sh[i]->sel_pt)continue;
			if(sh[i]->select_chk(r))f=true;
		}
	}else{
		for(int i=cnt;i<cnt+gc;i++){
			if(sh[i]->sel_pt)continue;
			if(sh[i]->select_chk(r))f=true;
		}
	}
	return(f);
}

void glyph::sel_none()
{
	for(int i=0;i<cnt+gc;i++)sh[i]->sel_pt=0;
}

void glyph::sel_to_top()
{
	int	c=cnt-1;
	for(int i=cnt-1;i>=0;i--){
		if(sh[i]->sel_pt==0)continue;
		shape	*t=sh[i];
		for(int j=i+1;j<=c;j++)sh[j-1]=sh[j];
		sh[c--]=t;
	}
}

void glyph::sel_to_bot()
{
	int	c=0;
	for(int i=0;i<cnt;i++){
		if(sh[i]->sel_pt==0)continue;
		shape	*t=sh[i];
		for(int j=i-1;j>=c;j--)sh[j+1]=sh[j];
		sh[c++]=t;
	}
}

void glyph::sel_first()
{
	if(gc==0){
		sh[0]->sel_pt=-1;
		for(int i=1;i<cnt;i++)sh[i]->sel_pt=0;
	}else{
		sh[cnt]->sel_pt=-1;
		for(int i=cnt+1;i<cnt+gc;i++)sh[i]->sel_pt=0;
	}
}

void glyph::sel_last()
{
	if(gc==0){
		for(int i=0;i<cnt-1;i++)sh[i]->sel_pt=0;
		sh[cnt-1]->sel_pt=-1;
	}else{
		for(int i=cnt;i<cnt+gc-1;i++)sh[i]->sel_pt=0;
		sh[cnt+gc-1]->sel_pt=-1;
	}
}

void glyph::sel_next()
{
	int	c=0;
	if(gc==0){
		for(int i=cnt-1;i>=0;i--){
			if(sh[i]->sel_pt==0)continue;
			sh[i]->sel_pt=0;
			c=i;
		}
		if(--c<0)c=cnt-1;
	}else{
		for(int i=cnt+gc-1;i>=cnt;i--){
			if(sh[i]->sel_pt==0)continue;
			sh[i]->sel_pt=0;
			c=i;
		}
		if(--c<cnt)c=cnt+gc-1;
	}
	sh[c]->sel_pt=-1;
}

void glyph::sel_back()
{
	int	c=cnt+gc;
	if(gc==0){
		for(int i=0;i<cnt;i++){
			if(sh[i]->sel_pt==0)continue;
			sh[i]->sel_pt=0;
			c=i;
		}
		if(++c>=cnt)c=0;
	}else{
		for(int i=cnt;i<cnt+gc;i++){
			if(sh[i]->sel_pt==0)continue;
			sh[i]->sel_pt=0;
			c=i;
		}
		if(++c>=cnt+gc)c=cnt;
	}
	sh[c]->sel_pt=-1;
}

void glyph::trans(const BRect &from,const BRect &to)
{
	for(int i=0;i<cnt+gc;i++)sh[i]->trans(from,to);
}

void glyph::draw(BView *v,uint32 col)
{
	for(int i=0;i<cnt;i++)sh[i]->draw(v,col);
}

void glyph::drawframe(BView *v,float pz)
{
	if(gc==0){
		for(int i=0;i<cnt;i++)sh[i]->drawframe(v,pz);
	}else{
		for(int i=cnt;i<cnt+gc;i++)sh[i]->drawframe(v,pz);
	}
}

int glyph::del_compo(uchar no)
{
	if(no>=gc)return(1);
	delete gl[no];
	gc--;
	for(int i=no;i<gc;i++){
		gl[i]=gl[i+1];
		ox[i]=ox[i+1];
		oy[i]=oy[i+1];
		sc00[i]=sc00[i+1];
		sc01[i]=sc01[i+1];
		sc10[i]=sc10[i+1];
		sc11[i]=sc11[i+1];
	}
	return(0);
}

int glyph::add_compo(glyph *sub,int16 x,int16 y,uint16 k00,uint16 k01,uint16 k10,uint16 k11)
{
	if(gc>=MAX_COMPONENT-1)return(1);
	gl[gc]=sub;
	ox[gc]=x;
	oy[gc]=y;
	sc00[gc]=k00;
	sc01[gc]=k01;
	sc10[gc]=k10;
	sc11[gc]=k11;
	gc++;
	return(0);
}

void glyph::create_composhape()
{
	for(int ig=0;ig<gc;ig++){
		glyph	*sg=gl[ig];		//sub-glyph
		for(int is=0;is<sg->cnt;is++){
			shape	*ss=sg->sh[is];	//sub-glyph-shape
			sh[cnt]=ss->transcopy(ox[ig],oy[ig],sc00[ig],sc01[ig],sc10[ig],sc11[ig]);
			sh[cnt]->ctrlp2form();
			cnt++;
		}
	}
	int	js=0;
	for(int ig=0;ig<gc;ig++){
		BRect	re(FLT_MAX,FLT_MAX,FLT_MIN,FLT_MIN);
		glyph	*sg=gl[ig];		//sub-glyph
		for(int is=0;is<sg->cnt;is++){
			re=re|sh[js]->rec;
			js++;
		}
		sh[cnt+ig]=new shape(4);
		sh[cnt+ig]->set(0,re.LeftTop(),0);
		sh[cnt+ig]->set(1,re.RightTop(),0);
		sh[cnt+ig]->set(2,re.RightBottom(),0);
		sh[cnt+ig]->set(3,re.LeftBottom(),0);
	}
}

void glyph::clr_composhape()
{
	for(int i=0;i<cnt+gc;i++)delete sh[i];
	cnt=0;
}

BRect glyph::bounds()const
{
	BRect	r(FLT_MAX,FLT_MAX,FLT_MIN,FLT_MIN);
	for(int i=0;i<cnt;i++)r=r|sh[i]->rec;
	return(r);
}
//------------------------------------------------
//------------------------------------------------
object::object(int points)
{
	if(points){
		pts=points;
		pt=new BPoint[pts];
	}else{	//for variable-points
		pts=0;
		pt=new BPoint[256];
	}
	cpts=0;
	sel_pt=0;
}

object::~object()
{
#if	__INTEL__
	if(pt)delete pt;
#endif
}

int object::create(const uchar &mf,const BPoint &mp,uchar psize)
{
return(-1);
}

void object::drawframe(BView *v,float scale)
{
}

shape** object::to_shape()
{
	return(NULL);
}
//------------------------------------------------
object_r::object_r():object(4)
{
}

int object_r::create(const uchar &mf,const BPoint &mp,uchar psize)
{
	if((mf==PRESS)&&(cpts==0)){
		pt[3]=pt[2]=pt[1]=pt[0]=mp;
		cpts=1;
	}
	if((mf==PRESSMOVE)&&(cpts==1)){
		pt[2].x=pt[1].x=mp.x;
		pt[3].y=pt[2].y=mp.y;
	}
	if((mf==RELEASE)&&(cpts==1)){
		pt[2].x=pt[1].x=mp.x;
		pt[3].y=pt[2].y=mp.y;
		cpts=-1;		//create complete
	}
	return(cpts);
}

void object_r::drawframe(BView *v,float scale)
{
	v->SetDrawingMode(B_OP_INVERT);
	v->StrokeRect(BRect(pt[0].x*scale,pt[0].y*scale,pt[2].x*scale,pt[2].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}
//------------------------------------------------
object_l::object_l():object(0)
{
}

int object_l::create(const uchar &mf,const BPoint &mp,uchar psize)
{
	if(mf==PRESS){
		if(cpts==0){
			pt[pts++]=mp;	//start
			pt[pts++]=mp;	//next
			cpts++;
		}else{
			BRect	rp(pt[cpts-1].x-2,pt[cpts-1].y-2,pt[cpts-1].x+2,pt[cpts-1].y+2);
			if(rp.Contains(mp)){	//create complete
				pts--;
				cpts=-1;
			}else{
				pt[cpts++]=mp;
				pt[pts++]=mp;	//next
			}
		}
	}
	if((mf==RELEASEMOVE)&&(cpts)){
		pt[pts-1]=mp;
	}
	if(mf==CANSEL){
		cpts--;pts--;
		if(pts<2){
			pts=0;cpts=-2;
		}else{
			pt[pts-1]=mp;
		}
	}
	return(cpts);
}
//------------------------------------------------
obj_free::obj_free():object(0)
{
	objtype=FREE;
}

int obj_free::create(const uchar &mf,const BPoint &mp,uchar psize)
{
	if(pts==0)psz=psize;
	if((pts==0)||(mp!=pt[pts-1])){
		if((pts&255)==0){
			BPoint	*t=new BPoint[pts+256];
			for(int i=0;i<pts;i++)t[i]=pt[i];
#if	__INTEL__
			delete pt;
#endif
			pt=t;
		}
		pt[pts++]=mp;
	}
	cpts=pts;
	if(mf==RELEASE)cpts=pts>1?-1:-2;

	return(cpts);
}

void obj_free::drawframe(BView *v,float scale)
{
	v->PushState();
v->SetPenSize(psz);
	v->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	for(int i=1;i<pts;i++){v->StrokeLine(pt[i-1],pt[i]);}
	v->PopState();
}

shape** obj_free::to_shape()
{
	BRect	rr=BRect(0,0,(canvas.right+1)/2-1,(canvas.bottom+1)/2-1);
	BView	*wv=new BView(rr,"obj_free",B_FOLLOW_NONE,0);
	wv->SetHighColor(0xff,0xff,0xff);
	wv->SetLowColor(0x00,0x00,0x00);
wv->SetPenSize(psz/2);
	wv->SetLineMode(B_ROUND_CAP,B_ROUND_JOIN);
	BBitmap	*bm=new BBitmap(wv->Bounds(),B_RGB_32_BIT,true);
	bm->Lock();
	bm->AddChild(wv);
	wv->FillRect(rr,B_SOLID_LOW);
	wv->MovePenTo(BPoint(pt[0].x/2,pt[0].y/2));
	for(int i=1;i<pts;i++)wv->StrokeLine(BPoint(pt[i].x/2,pt[i].y/2));
	bm->RemoveChild(wv);
	bm->Unlock();
	delete wv;

	int	w=rr.Width()+1;
	int	h=rr.Height()+1;
	int	t1l=(w+2)*(h+2);
	uchar	*t1=new uchar[t1l];
	for(int i=0;i<t1l;i++)t1[i]=0;
	uchar	*p=(uchar*)(bm->Bits());
	for(int ih=0;ih<h;ih++)for(int iw=0;iw<w;iw++){
		int	r,g,b,a;
		r=*(p++);g=*(p++);b=*(p++);a=*(p++);
		if((r+g+b)>0x180)t1[(ih+1)*(w+2)+(iw+1)]=1;
	}
	delete bm;

	int	t2l=w*h*2+w*3+h*3+4;
	uchar	*t2=new uchar[t2l];
	for(int i=0;i<t2l;i++)t2[i]=0;
	for(int ix=0;ix<w;ix++)for(int iy=0;iy<=h;iy++){
		t2[(w*2+3)*iy+(w+2+ix)]=t1[iy*(w+2)+(ix+1)]^t1[(iy+1)*(w+2)+(ix+1)];
	}
	for(int iy=0;iy<h;iy++)for(int ix=0;ix<=w;ix++){
		t2[(w*2+3)*(iy+1)+ix]=t1[(iy+1)*(w+2)+ix]^t1[(iy+1)*(w+2)+(ix+1)];
	}

	static uchar	dd[12]={	11,1,6,8,4,9,2,7,3,5,10,0	};
	int	ddd[12];
	ddd[0]=-w-1;ddd[1]=1;ddd[2]=w+2;ddd[3]=w+1;ddd[4]=-1;ddd[5]=-w-2;
	ddd[6]=w+2;ddd[7]=w*2+3;ddd[8]=w+1;ddd[9]=-w-2;ddd[10]=-w*2-3;ddd[11]=-w-1;

	BPoint	*tp=new BPoint[t2l];
	int	tpc=0;
	int	*ti=new int[257];			//max shapes=256
	int	sc=0;

	for(int i=0;i<t2l;i++){
		if(t2[i]==0)continue;
		ti[sc]=tpc;
		int	y=(i-w-1)/(w*2+3);
		int	x=(i-w-1)-y*(w*2+3)-1;
		uchar	d=t1[(y+1)*(w+2)+(x+1)]?1:4;
		for(int j=i;;j+=ddd[d]){
			y=(j-w-1)/(w*2+3);
			x=(j-w-1)-y*(w*2+3)-1;
			if(d<6){
				tp[tpc++]=BPoint(x*2+1,y*2);
			}else{
				x-=w+1;
				tp[tpc++]=BPoint(x*2,y*2+1);
			}
			t2[j]=0;
			d/=3;
			if(t2[j+ddd[dd[d*3]]])d=dd[d*3];
			else if(t2[j+ddd[dd[d*3+1]]])d=dd[d*3+1];
			else if(t2[j+ddd[dd[d*3+2]]])d=dd[d*3+2];
			else break;
		}
		//set-end
		if(tpc>ti[sc])ti[++sc]=tpc;
		if(sc>255)break;			//max shapes=256
	}
	delete t1;delete t2;

	shape	**ss=new shape*[sc+1];
	for(int j=0;j<sc;j++){
	int	th=(ti[j+1]-ti[j])/100;
		if(th){if(th<20)th=20;}else th=(ti[j+1]-ti[j])/3;
		int	c=0;
		shape	*sh=new shape((ti[j+1]-ti[j]+th-1)/th);
		for(int i=ti[j];i<ti[j+1];i+=th)sh->set(c++,tp[i],1);		//all control//anchor
	 	sh->ctrlp2form();
		ss[j]=sh;
	}
	ss[sc]=NULL;

	delete ti;
#if	__INTEL__
	delete tp;
#endif

	return(ss);
}

//------------------------------------------------
obj_rect::obj_rect():object_r()
{
	objtype=RECT;
}

shape** obj_rect::to_shape()
{
	shape	*sh=new shape(4);
	for(int i=0;i<4;i++)sh->set(i,pt[i],0);		//all anchor
	sh->ctrlp2form();

	shape	**ss=new shape*[2];
	ss[0]=sh;ss[1]=NULL;
	return(ss);
}
//------------------------------------------------
obj_ellipse::obj_ellipse():object_r()
{
	objtype=ELLIPSE;
}

void obj_ellipse::drawframe(BView *v,float scale)
{
	v->SetDrawingMode(B_OP_INVERT);
	v->StrokeEllipse(BRect(pt[0].x*scale,pt[0].y*scale,pt[2].x*scale,pt[2].y*scale),B_MIXED_COLORS);
	v->SetDrawingMode(B_OP_COPY);
}

shape** obj_ellipse::to_shape()
{
	shape	*sh=new shape(8);
	float	ox=(pt[0].x+pt[1].x)/2;
	float	oy=(pt[0].y+pt[3].y)/2;
	float	rx=(pt[1].x-pt[0].x)/2;
	float	ry=(pt[3].y-pt[0].y)/2;
	float	k=sqrt(2)-1;
	sh->set(0,BPoint(ox-rx*k,oy-ry),1);
	sh->set(1,BPoint(ox+rx*k,oy-ry),1);
	sh->set(2,BPoint(ox+rx,oy-ry*k),1);
	sh->set(3,BPoint(ox+rx,oy+ry*k),1);
	sh->set(4,BPoint(ox+rx*k,oy+ry),1);
	sh->set(5,BPoint(ox-rx*k,oy+ry),1);
	sh->set(6,BPoint(ox-rx,oy+ry*k),1);
	sh->set(7,BPoint(ox-rx,oy-ry*k),1);

	sh->ctrlp2form();

	shape	**ss=new shape*[2];
	ss[0]=sh;ss[1]=NULL;
	return(ss);
}
//------------------------------------------------
obj_polygon::obj_polygon():object_l()
{
	objtype=POLY;
}

void obj_polygon::drawframe(BView *v,float scale)
{
	v->SetDrawingMode(B_OP_INVERT);
	v->MovePenTo(pt[0].x*scale,pt[0].y*scale);
	for(int i=1;i<pts;i++)v->StrokeLine(BPoint(pt[i].x*scale,pt[i].y*scale),B_MIXED_COLORS);
	if(pts>2)v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),B_MIXED_COLORS);
v->MovePenTo(0,0);
	v->SetDrawingMode(B_OP_COPY);
}

shape** obj_polygon::to_shape()
{
	shape	*sh=new shape(pts);
	for(int i=0;i<pts;i++)sh->set(i,pt[i],0);		//all anchor
	sh->ctrlp2form();

	shape	**ss=new shape*[2];
	ss[0]=sh;ss[1]=NULL;
	return(ss);
}
//------------------------------------------------
obj_round::obj_round():object_l()
{
	objtype=ROUND;
}

void obj_round::drawframe(BView *v,float scale)
{
	v->SetDrawingMode(B_OP_INVERT);
	if(pts>2){
		BShape	bs;
		BPoint	q[4];
		bs.MoveTo(BPoint((pt[0].x+pt[1].x)/2*scale,(pt[0].y+pt[1].y)/2*scale));
		for(int i=0;i<pts;i++){
			q[0]=BPoint((pt[i].x+pt[(i+1)%pts].x)/2,(pt[i].y+pt[(i+1)%pts].y)/2);
			q[3]=BPoint((pt[(i+1)%pts].x+pt[(i+2)%pts].x)/2,(pt[(i+1)%pts].y+pt[(i+2)%pts].y)/2);
			q[1]=BPoint((q[0].x+pt[(i+1)%pts].x*2)/3,(q[0].y+pt[(i+1)%pts].y*2)/3);
			q[2]=BPoint((q[3].x+pt[(i+1)%pts].x*2)/3,(q[3].y+pt[(i+1)%pts].y*2)/3);

//			q[0]=BPoint(q[0].x*scale,q[0].y*scale);
			q[1]=BPoint(q[1].x*scale,q[1].y*scale);
			q[2]=BPoint(q[2].x*scale,q[2].y*scale);
			q[3]=BPoint(q[3].x*scale,q[3].y*scale);
			bs.BezierTo(q+1);
		}
		v->MovePenTo(BPoint(0,0));
		v->StrokeShape(&bs,B_MIXED_COLORS);
	}else{
		v->StrokeLine(BPoint(pt[0].x*scale,pt[0].y*scale),BPoint(pt[1].x*scale,pt[1].y*scale),B_MIXED_COLORS);
	}
v->MovePenTo(0,0);
	v->SetDrawingMode(B_OP_COPY);
}

shape** obj_round::to_shape()
{
	shape	*sh=new shape(pts);
	for(int i=0;i<pts;i++)sh->set(i,pt[i],1);		//all control
	sh->ctrlp2form();

	shape	**ss=new shape*[2];
	ss[0]=sh;ss[1]=NULL;
	return(ss);
}
//------------------------------------------------
//------------------------------------------------
bitmap::bitmap(uint16 no,uchar width,uchar height,uchar depth)
{
	gno=no;
	ppemx=width;
	ppemy=height;
	dep=depth;

	w=0;h=0;
	bx=0;by=0;
	ad=width;
	dat=NULL;

	vr=BRect(0,0,0,0);
}

bitmap::~bitmap()
{
	if(dat)delete dat;
}

void bitmap::setvrect(const BRect &to)
{
	vr=to;
}

void bitmap::draw(BView *v)
{
	v->SetHighColor(255,255,255);
	if(dat==NULL){
		v->DrawString("Undefined",BPoint(vr.left*.6+vr.right*.4,vr.top*.6+vr.bottom*.4));
		return;
	}
	float	ox,oy,ow,oh;
	ow=(vr.Width()+1)/ppemx;	oh=(vr.Height()+1)/ppemy;
	ox=vr.left+ow*bx;	oy=vr.top+oh*(ppemy-by);
	uchar	*p=dat;
	for(int ih=0;ih<h;ih++){
		for(int iw=0;iw<w;iw++){
			if(*(p++)==0)continue;
			v->FillRect(BRect(ox+ow*iw,oy+oh*ih,ox+ow*(iw+1)-1,oy+oh*(ih+1)-1));
		}
	}
	v->SetHighColor(100,100,100);
	v->StrokeRect(BRect(ox,oy,ox+ow*w-1,oy+oh*h-1));
}

int bitmap::create(const uchar &mf,const BPoint &mp)
{
	float	ox,oy,ow,oh;
	ow=(vr.Width()+1)/ppemx;	oh=(vr.Height()+1)/ppemy;
	ox=vr.left+ow*bx;	oy=vr.top+oh*(ppemy-by);

	int	x,y;
	x=mp.x-ox;	y=mp.y-oy;
	if((x<0)||(y<0))return(1);
	x/=ow;	y/=oh;
	if((x>=w)||(y>=h))return(1);

	uchar	*p=dat+w*y+x;
	*p=((*p)+1)&1;
	return(0);
}
//------------------------------------------------
//------------------------------------------------
ttf::ttf()
{
	ittf=NULL;
	header=NULL;
	os2=NULL;	cmap=NULL;	glyf=NULL;	head=NULL;	hhea=NULL;
	hmtx=NULL;	loca=NULL;	maxp=NULL;	name=NULL;	post=NULL;
	for(int i=0;i<16;i++)etc[i]=NULL;
	gasp=NULL;	ebdt=NULL;	eblc=NULL;
}

ttf::~ttf()
{
	if(ittf)delete ittf;
	if(header)delete header;
	if(os2)delete os2;
	if(cmap)delete cmap;
	if(glyf)delete glyf;
	if(head)delete head;
	if(hhea)delete hhea;
	if(hmtx)delete hmtx;
	if(loca)delete loca;
	if(maxp)delete maxp;
	if(name)delete name;
	if(post)delete post;
	for(int i=0;i<16;i++)if(etc[i])delete etc[i];
	if(gasp)delete gasp;
	if(ebdt)delete ebdt;
	if(eblc)delete eblc;
}

int ttf::init()
{
	static uint32	table[]={	'OS/2','cmap','glyf','head','hhea',
								'hmtx','loca','maxp','name','post',
								0	};
	int		etcs=0;
	int		tbls=-1;
	while(table[++tbls]);
	int		headerl=12+tbls*16;
	header=new uchar[headerl];

	uint16	es,sr;
	es=0;	sr=1;
	while(sr*2<=tbls){sr*=2;es++;}
	sr*=16;
	*(uint32*)(header+0)=B_HOST_TO_BENDIAN_INT32(0x10000);		//sfntVersion
	*(uint16*)(header+4)=B_HOST_TO_BENDIAN_INT16(tbls);			//numTables
	*(uint16*)(header+6)=B_HOST_TO_BENDIAN_INT16(sr);			//searchRange
	*(uint16*)(header+8)=B_HOST_TO_BENDIAN_INT16(es);			//entrySelector
	*(uint16*)(header+10)=B_HOST_TO_BENDIAN_INT16(tbls*16-sr);	//rangeShift

	uint32	*p=(uint32*)(header+12);
	for(int i=0;i<tbls;i++){
		uint32	tname=table[i];
		*(p++)=B_HOST_TO_BENDIAN_INT32(tname);
		*(p++)=0;*(p++)=0;*(p++)=0;
printf("name=[%c%c%c%c]\n",tname>>24,tname>>16,tname>>8,tname);
		if(tname=='OS/2')os2=new ttf_os2(this);
		else if(tname=='cmap')cmap=new ttf_cmap(this);
		else if(tname=='glyf')glyf=new ttf_glyf(this);
		else if(tname=='head')head=new ttf_head(this);
		else if(tname=='hhea')hhea=new ttf_hhea(this);
		else if(tname=='hmtx')hmtx=new ttf_hmtx(this);
		else if(tname=='loca')loca=new ttf_loca(this);
		else if(tname=='maxp')maxp=new ttf_maxp(this);
		else if(tname=='name')name=new ttf_name(this);
		else if(tname=='post')post=new ttf_post(this);
		else etc[etcs++]=new ttf_table(this,tname);
	}
	
	cmap->get_tbl();

	if(ittf){delete ittf;ittf=NULL;}
	return(0);
}

int ttf::load(BFile &f)
{
printf("ttf:load\n");
	int		etcs=0;
	char	bufh[16];
	f.Seek(0,SEEK_SET);	f.Read(bufh,12);
	if(B_BENDIAN_TO_HOST_INT32(*(uint32*)bufh)!=0x10000)return(1);	//sfntVersion
	int		tbls=B_BENDIAN_TO_HOST_INT16(*(uint16*)(bufh+4));
	int		headerl=12+tbls*16;
	header=new uchar[headerl];
	f.Seek(0,SEEK_SET);	f.Read(header,headerl);
	for(int i=0;i<tbls;i++){
		uint32	*p=(uint32*)(header+12+i*16);
		uint32	tname=B_BENDIAN_TO_HOST_INT32(*(p+0));
printf("name=[%c%c%c%c]\n",tname>>24,tname>>16,tname>>8,tname);
		uint32	off=B_BENDIAN_TO_HOST_INT32(*(p+2));
		uint32	len=B_BENDIAN_TO_HOST_INT32(*(p+3));
		uchar	*buft=malloc32(len);
		f.Seek(off,SEEK_SET);	f.Read(buft,len);
		if(tname=='OS/2')os2=new ttf_os2(this,buft,len);
		else if(tname=='cmap')cmap=new ttf_cmap(this,buft,len);
		else if(tname=='glyf')glyf=new ttf_glyf(this,buft,len);
		else if(tname=='head')head=new ttf_head(this,buft,len);
		else if(tname=='hhea')hhea=new ttf_hhea(this,buft,len);
		else if(tname=='hmtx')hmtx=new ttf_hmtx(this,buft,len);
		else if(tname=='loca')loca=new ttf_loca(this,buft,len);
		else if(tname=='maxp')maxp=new ttf_maxp(this,buft,len);
		else if(tname=='name')name=new ttf_name(this,buft,len);
		else if(tname=='post')post=new ttf_post(this,buft,len);
		else if(tname=='gasp')gasp=new ttf_gasp(this,buft,len);
		else if(tname=='EBDT')ebdt=new ttf_ebdt(this,buft,len);
		else if(tname=='EBLC')eblc=new ttf_eblc(this,buft,len);
		else etc[etcs++]=new ttf_table(this,tname,buft,len);
	}
	
	cmap->get_tbl();
	return(0);
}

int ttf::save(BFile &f)
{
printf("ttf:save\n");
	maxp->update();
	head->update();

	uint32	tsum=0;
	uint32	hpos=0;
	head->setsum();	//clr
	int		etcs=0;
	int		tbls=B_BENDIAN_TO_HOST_INT16(*(uint16*)(header+4));
	int		headerl=12+tbls*16;
	uint32	off=headerl;
	for(int i=0;i<tbls;i++){
		uint32	*p=(uint32*)(header+12+i*16);
		uint32	tname=B_BENDIAN_TO_HOST_INT32(*(p+0));
printf("name=[%c%c%c%c]\n",tname>>24,tname>>16,tname>>8,tname);
		ttf_table	*ttft;
		if(tname=='OS/2')ttft=os2;
		else if(tname=='cmap')ttft=cmap;
		else if(tname=='glyf')ttft=glyf;
		else if(tname=='head'){ttft=head;hpos=off;}
		else if(tname=='hhea')ttft=hhea;
		else if(tname=='hmtx')ttft=hmtx;
		else if(tname=='loca')ttft=loca;
		else if(tname=='maxp')ttft=maxp;
		else if(tname=='name')ttft=name;
		else if(tname=='post')ttft=post;
		else if(tname=='gasp')ttft=gasp;
		else if(tname=='EBDT')ttft=ebdt;
		else if(tname=='EBLC')ttft=eblc;
		else ttft=etc[etcs++];
		uint32	sum=ttft->sumB32();
		*(p+1)=B_HOST_TO_BENDIAN_INT32(sum);
		*(p+2)=B_HOST_TO_BENDIAN_INT32(off);
		uint32	len=ttft->tbl_size;
		*(p+3)=B_HOST_TO_BENDIAN_INT32(len);
		while(len&3)len++;		///
		f.Seek(off,SEEK_SET);	f.Write(ttft->tbl_dat,len);
		off+=len;
		tsum+=sum;
	}
	f.Seek(0,SEEK_SET);	f.Write(header,headerl);
	for(int i=0;i<headerl;i+=4)tsum+=B_BENDIAN_TO_HOST_INT32(*(header+i));
	head->setsum(tsum);
	f.Seek(hpos,SEEK_SET);	f.Write(head->tbl_dat,head->tbl_size);
	return(0);
}

void ttf::set_view(BView *v)
{
	if(os2){os2->show(false);v->AddChild(os2);}
	if(cmap){cmap->show(false);v->AddChild(cmap);}
	if(glyf){glyf->show(false);v->AddChild(glyf);}
	if(head){head->show(false);v->AddChild(head);}
	if(hhea){hhea->show(false);v->AddChild(hhea);}
	if(hmtx){hmtx->show(false);v->AddChild(hmtx);}
	if(maxp){maxp->show(false);v->AddChild(maxp);}
	if(name){name->show(false);v->AddChild(name);}
	if(post){post->show(false);v->AddChild(post);}
	if(gasp){gasp->show(false);v->AddChild(gasp);}
	if(ebdt){ebdt->show(false);v->AddChild(ebdt);}
	if(eblc){eblc->show(false);v->AddChild(eblc);}

	glyf->ev->chgscale(0);
	if(ebdt)ebdt->tv->init();
}

void ttf::reset_view(BView *v)
{
	if(os2)v->RemoveChild(os2);
	if(cmap)v->RemoveChild(cmap);
	if(glyf)v->RemoveChild(glyf);
	if(head)v->RemoveChild(head);
	if(hhea)v->RemoveChild(hhea);
	if(hmtx)v->RemoveChild(hmtx);
	if(maxp)v->RemoveChild(maxp);
	if(name)v->RemoveChild(name);
	if(post)v->RemoveChild(post);
	if(gasp)v->RemoveChild(gasp);
	if(ebdt)v->RemoveChild(ebdt);
	if(eblc)v->RemoveChild(eblc);
}

int ttf::get_tables(int *count,uint32 *name)
{
	int		tbls=B_BENDIAN_TO_HOST_INT16(*(uint16*)(header+4));
	if(tbls>*count)return(-1);	//too many
	*count=tbls;
	for(int i=0;i<tbls;i++)name[i]=B_BENDIAN_TO_HOST_INT32(*(uint32*)(header+12+i*16));
	return(0);
}

BRect ttf::bounds()
{
	BRect	r=head->bounds();
	int	w,h,s;
	w=r.Width()+1;
	h=-r.Height()+1;	//because height<0
	s=w>h?w:h;
	s=(s+511)&512;
	return(r);
}

int ttf::get_glyph(int g_no,glyph *gl)
{
	if(g_no>=maxp->numglyphs())return(-1);
	uint32	off,len;
	if(loca->get_offset(head->is32loca(),g_no,&off,&len))return(-1);
	if(len)glyf->decode(off,len,gl);
	return(0);
}

int ttf::set_glyph(int g_no,const glyph *gl)
{
	if(g_no>=maxp->numglyphs())return(-1);
	uint32	off,len;
	if(loca->get_offset(head->is32loca(),g_no,&off,&len))return(-1);
	glyf->encode(gl,&off,&len);
	if(loca->chg_length(head->is32loca(),g_no,len))return(-1);
	return(0);
}

int ttf::get_bitmap(bitmap *bm)
{
	uint32	off;
	uint16	imgfmt;
	if(eblc->get_offset(bm,&off,&imgfmt))return(-1);
	if(ebdt->decode(off,imgfmt,bm))return(-1);
	return(0);
}

int ttf::set_bitmap(bitmap *bm)
{
	uint32	off;
	uint16	imgfmt;
	if(eblc->get_offset(bm,&off,&imgfmt))return(-1);
	if(ebdt->encode(bm,off,imgfmt))return(-1);
	return(0);
}
//------------------------------------------------
ttf_table::ttf_table(ttf *p,uint32 tname,uchar *dat,uint32 size):BView(BRect(0,0,561,511),"table",B_FOLLOW_ALL_SIDES/*|B_FRAME_EVENTS*/,B_WILL_DRAW)
{
	pak=p;
	tbl_name=tname;
	tbl_dat=dat;
	tbl_size=size;
}

ttf_table::~ttf_table()
{
	if(tbl_dat)delete tbl_dat;
}

void ttf_table::show(bool f)
{
	if(f)while(IsHidden())Show();
	else while(!IsHidden())Hide();
}

uint32 ttf_table::sumB32()
{
	uint32	sum=0;
	uint32	*p=(uint32*)tbl_dat;
	int		len=tbl_size/4;
	while(len--)sum+=B_BENDIAN_TO_HOST_INT32(*(p++));
	return(sum);
}
//------------------------------------------------
ttf_os2::ttf_os2(ttf *p,uchar *dat,uint32 size):ttf_table(p,'OS/2',dat,size)
{
	if(dat==NULL)create_default();
}

ttf_os2::~ttf_os2()
{
}

void ttf_os2::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	redraw();
}

void ttf_os2::redraw()
{
	static const char	tn[41][32]={
		"version",
		"xAvgCharWidth",
		"usWeightClass",
		"usWidthClass",
		"fsType",
		"ySubscriptXSize",
		"ySubscriptYSize",
		"ySubscriptXOffset",
		"ySubscriptYOffset",
		"ySuperscriptXSize",
		"ySuperscriptYSize",
		"ySuperscriptXOffset",
		"ySuperscriptYOffset",
		"yStrikeoutSize",
		"yStrikeoutPosition",
		"sFamilyClass",

		"panose(FamilyKind)",
		"panose(SerifStyle)",
		"panose(Weight)",
		"panose(Proportion)",
		"panose(Contrast)",
		"panose(StrokeVariation)",
		"panose(ArmStyle)",
		"panose(Letterform)",
		"panose(Midline)",
		"panose(X-height)",

		"ulUnicodeRange1",
		"ulUnicodeRange2",
		"ulUnicodeRange3",
		"ulUnicodeRange4",
		"achVendID",
		"fsSelection",
		"usFirstCharIndex",
		"usLastCharIndex",
		"sTypoAscender",
		"sTypoDescender",
		"sTypoLineGap",
		"usWinAscent",
		"usWinDescent",
		"ulCodePageRange1",
		"ulCodePageRange2"
	};

	int	x,y;
	x=20;
	for(int i=0;i<16;i++){
		y=i*15+20;
		DrawString(tn[i],BPoint(x,y));
	}
	for(int i=0;i<10;i++){
		y=i*15+270;
		DrawString(tn[i+16],BPoint(x,y));
	}
	x=300;
	for(int i=0;i<15;i++){
		y=i*15+20;
		DrawString(tn[i+26],BPoint(x,y));
	}


	uchar	*p=tbl_dat;
	x=170;
	for(int i=0;i<16;i++){
		y=i*15+20;
		char	s[16];
		sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
		p+=2;
		DrawString(s,BPoint(x,y));
	}
	for(int i=0;i<10;i++){
		y=i*15+270;
		char	s[16];
		sprintf(s,"%02x",*p);
		p+=1;
		DrawString(s,BPoint(x,y));
	}
	x=450;
	for(int i=0;i<15;i++){
		y=i*15+20;
		char	s[16];
		if((i<5)||(i>12)){
			sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
			if(i==4)sprintf(s,"%s (%c%c%c%c)",s,*p,*(p+1),*(p+2),*(p+3));
			p+=4;
		}else{
			sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
			p+=2;
		}
		DrawString(s,BPoint(x,y));
	}
}

void ttf_os2::create_default()
{
	tbl_dat=malloc32(tbl_size=86);

	uint32	ur[4];
	ur[0]=ur[1]=ur[2]=ur[3]=0;
	for(int i=0;i<71;i++){
		if(pak->ittf->ub[i])ur[i/32]|=(1<<(i&31));
	}

	uchar	*p=tbl_dat;
	*(uint16*)(p+0)=B_HOST_TO_BENDIAN_INT16(0x0001);		//version
	*(uint16*)(p+2)=B_HOST_TO_BENDIAN_INT16(512);			//xAvgCharWidth
	*(uint16*)(p+4)=B_HOST_TO_BENDIAN_INT16(500);			//usWeightClass
	*(uint16*)(p+6)=B_HOST_TO_BENDIAN_INT16(5);				//usWidthClass
	*(uint16*)(p+8)=B_HOST_TO_BENDIAN_INT16(4);				//fsType
	*(uint16*)(p+10)=B_HOST_TO_BENDIAN_INT16(256);			//ySubscriptXSize
	*(uint16*)(p+12)=B_HOST_TO_BENDIAN_INT16(256);			//ySubscriptYSize
	*(uint16*)(p+14)=B_HOST_TO_BENDIAN_INT16(0);			//ySubscriptXOffset
	*(uint16*)(p+16)=B_HOST_TO_BENDIAN_INT16(256);			//ySubscriptYOffset
	*(uint16*)(p+18)=B_HOST_TO_BENDIAN_INT16(256);			//ySuperscriptXSize
	*(uint16*)(p+20)=B_HOST_TO_BENDIAN_INT16(256);			//ySuperscriptYSize
	*(uint16*)(p+22)=B_HOST_TO_BENDIAN_INT16(0);			//ySuperscriptXOffset
	*(uint16*)(p+24)=B_HOST_TO_BENDIAN_INT16(256);			//ySuperscriptYOffset
	*(uint16*)(p+26)=B_HOST_TO_BENDIAN_INT16(16);			//yStrikeoutSize
	*(uint16*)(p+28)=B_HOST_TO_BENDIAN_INT16(256);			//yStrikeoutPosition
	*(uint16*)(p+30)=B_HOST_TO_BENDIAN_INT16(0);			//sFamilyClass
	*(uchar*)(p+32)=0x02;				//panose(FamilyKind)
	*(uchar*)(p+33)=0x00;				//panose(SerifStyle)
	*(uchar*)(p+34)=0x05;				//panose(Weight)
	*(uchar*)(p+35)=0x09;				//panose(Proportion)
	*(uchar*)(p+36)=0x00;				//panose(Contrast)
	*(uchar*)(p+37)=0x00;				//panose(StrokeVariation)
	*(uchar*)(p+38)=0x00;				//panose(ArmStyle)
	*(uchar*)(p+39)=0x00;				//panose(Letterform)
	*(uchar*)(p+40)=0x00;				//panose(Midline)
	*(uchar*)(p+41)=0x00;				//panose(X-height)
	*(uint32*)(p+42)=B_HOST_TO_BENDIAN_INT32(ur[0]);		//ulUnicodeRange1
	*(uint32*)(p+46)=B_HOST_TO_BENDIAN_INT32(ur[1]);		//ulUnicodeRange2
	*(uint32*)(p+50)=B_HOST_TO_BENDIAN_INT32(ur[2]);		//ulUnicodeRange3
	*(uint32*)(p+54)=B_HOST_TO_BENDIAN_INT32(ur[3]);		//ulUnicodeRange4
	*(uint32*)(p+58)=B_HOST_TO_BENDIAN_INT32('Beer');		//achVendID
	*(uint16*)(p+62)=B_HOST_TO_BENDIAN_INT16(0x40);			//fsSelection
	*(uint16*)(p+64)=B_HOST_TO_BENDIAN_INT16(0x0001);		//usFirstCharIndex
	*(uint16*)(p+66)=B_HOST_TO_BENDIAN_INT16(0xfffe);		//usLastCharIndex
	*(uint16*)(p+68)=B_HOST_TO_BENDIAN_INT16(512);			//sTypoAscender
	*(uint16*)(p+70)=B_HOST_TO_BENDIAN_INT16(0);			//sTypoDescender
	*(uint16*)(p+72)=B_HOST_TO_BENDIAN_INT16(0);			//sTypoLineGap
	*(uint16*)(p+74)=B_HOST_TO_BENDIAN_INT16(512);			//usWinAscent
	*(uint16*)(p+76)=B_HOST_TO_BENDIAN_INT16(0);			//usWinDescent
	*(uint32*)(p+78)=B_HOST_TO_BENDIAN_INT32(0xffffffff);	//ulCodePageRange1
	*(uint32*)(p+82)=B_HOST_TO_BENDIAN_INT32(0xffffffff);	//ulCodePageRange2
}
//------------------------------------------------
ttf_cmap::ttf_cmap(ttf *p,uchar *dat,uint32 size):ttf_table(p,'cmap',dat,size)
{
	c2g=new uint16[0x10000];
	if(dat==NULL)create_default();
}

ttf_cmap::~ttf_cmap()
{
	delete c2g;
}

void ttf_cmap::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	ms=new BMessage('Bhit');
	pb_set=new BButton(BRect(500,448,540,470),"set","set",ms);
	pb_set->SetTarget(this);
	AddChild(pb_set);

	ms=new BMessage('Vchg');
	tc_st=new BTextControl(BRect(20,450,120,470),"st","start_chr.","",ms);
	tc_st->SetTarget(this);
	AddChild(tc_st);

	ms=new BMessage('Vchg');
	tc_ed=new BTextControl(BRect(140,450,240,470),"ed","end_chr.","",ms);
	tc_ed->SetTarget(this);
	AddChild(tc_ed);

	ms=new BMessage('Vchg');
	tc_gno=new BTextControl(BRect(260,450,360,470),"gno","glyph_no.","",ms);
	tc_gno->SetTarget(this);
	AddChild(tc_gno);

	MakeFocus();
}

void ttf_cmap::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);
}

void ttf_cmap::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Vchg':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			char	s[8];
			int st,ed,gno;
			st=ed=gno=0;
			sscanf(tc_st->Text(),"%x",&st);
			sscanf(tc_ed->Text(),"%x",&ed);
			sscanf(tc_gno->Text(),"%x",&gno);
			if(from==tc_st){
				gno=get_gno(st);
			}
			sprintf(s,"%04x",st);	tc_st->SetText(s);
			sprintf(s,"%04x",ed);	tc_ed->SetText(s);
			sprintf(s,"%04x",gno);	tc_gno->SetText(s);
		}break;
		case 'Bhit':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			char	s[8];
			int st,ed,gno;
			st=ed=gno=0;
			sscanf(tc_st->Text(),"%x",&st);
			sscanf(tc_ed->Text(),"%x",&ed);
			sscanf(tc_gno->Text(),"%x",&gno);
			if(from==pb_set){
				if(st>ed)break;		//error
				if((gno!=0xffff)&&(gno>=pak->maxp->numglyphs()))break;	//error
				set_chr(st,ed,gno);
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_cmap::redraw()
{
}

void ttf_cmap::create_default()
{
	int	chrs=1;
	for(int i=0x0001;i<=0xffff;i++)c2g[i]=pak->ittf->c[i]?chrs++:0;
	set_tbl();
}

int ttf_cmap::get_tbl()
{
	for(int i=0;i<0x10000;i++)c2g[i]=0;

	uchar	*p=tbl_dat;
	uint16	tbls=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));

	uint32	off=0;
	for(int i=0;i<tbls;i++){
		uint16	pid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4+i*8+0));
		uint16	eid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4+i*8+2));
		if((pid==3)&&(eid==1))off=B_BENDIAN_TO_HOST_INT32(*(uint32*)(p+4+i*8+4));
	}
	if(off==0)return(-1);
	p+=off;

	uint16	fmt=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));	//format
	if(fmt!=4)return(1);		/////4.Segment mapping
	uint16	sc2=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+6));	//segCountX2
	uint16	*ecp=(uint16*)(p+14);							//endCount[segCount]
	uint16	*scp=(uint16*)(p+16+sc2);						//startCount[segCount]
	uint16	*idp=(uint16*)(p+16+sc2*2);						//idDelta[segCount]
	uint16	*irp=(uint16*)(p+16+sc2*3);						//idRangeOffset[segCount]

	while(*scp!=0xffff){
		uint16	sc=B_BENDIAN_TO_HOST_INT16(*scp);
		uint16	ec=B_BENDIAN_TO_HOST_INT16(*ecp);
		for(uint16 c=sc;c<=ec;c++){
			uint16	cc;
			if(*irp){
				cc=B_BENDIAN_TO_HOST_INT16(*(irp+(B_BENDIAN_TO_HOST_INT16(*irp)/2)+(c-B_BENDIAN_TO_HOST_INT16(*scp))))+(int16)B_BENDIAN_TO_HOST_INT16(*idp);
			}else{
				cc=c+(int16)B_BENDIAN_TO_HOST_INT16(*idp);
			}
			c2g[c]=cc;
		}
		scp++;ecp++;idp++;irp++;
	}
	return(0);
}

int ttf_cmap::set_tbl()
{
	if(tbl_dat){delete tbl_dat;tbl_dat=NULL;tbl_size=0;}

	c2g[0x0000]=0;	//error-character(not mapping)
	c2g[0xffff]=0;	//cannot use
	int	chrs=1;
	for(int i=0x0001;i<0xffff;i++)if(c2g[i])chrs++;

	uint	sc,sr,es;
	sc=1;sr=1;es=-1;
	for(int i=0x0000;i<0xfffe;i++)if((c2g[i]==0)&&(c2g[i+1]))sc++;
	while(sr<sc){sr<<=1;es++;}

	tbl_size=4+8+(sc*8+16);
	tbl_dat=malloc32(tbl_size);

	uchar	*p=tbl_dat;
	*(uint16*)(p+0)=B_HOST_TO_BENDIAN_INT16(0);			//version
	*(uint16*)(p+2)=B_HOST_TO_BENDIAN_INT16(1);			//tables=1
	*(uint16*)(p+4)=B_HOST_TO_BENDIAN_INT16(3);			//tbl-1 P-ID=3
	*(uint16*)(p+6)=B_HOST_TO_BENDIAN_INT16(1);			//      E-ID=1(unicode)
	*(uint32*)(p+8)=B_HOST_TO_BENDIAN_INT32(12);		//  	offset
	p+=12;
	*(uint16*)(p+0)=B_HOST_TO_BENDIAN_INT16(4);			//format=4(Segment mapping)
	*(uint16*)(p+2)=B_HOST_TO_BENDIAN_INT16(sc*8+16);	//length
	*(uint16*)(p+4)=B_HOST_TO_BENDIAN_INT16(0);			//version
	*(uint16*)(p+6)=B_HOST_TO_BENDIAN_INT16(sc*2);		//segCountX2
	*(uint16*)(p+8)=B_HOST_TO_BENDIAN_INT16(sr);		//searchRange
	*(uint16*)(p+10)=B_HOST_TO_BENDIAN_INT16(es);		//entrySelector
	*(uint16*)(p+12)=B_HOST_TO_BENDIAN_INT16(sc*2-sr);	//rangeShift
	uint16	*ecp=(uint16*)(p+14);						//endCode
	*(uint16*)(p+14+sc*2)=B_HOST_TO_BENDIAN_INT16(0);	//reserved
	uint16	*scp=(uint16*)(p+16+sc*2);					//startCode
	uint16	*idp=(uint16*)(p+16+sc*4);					//idDelta
	uint16	*irp=(uint16*)(p+16+sc*6);					//idRangeOffset
//	uint16	*gip=(uint16*)(p+16+sc*8);					//glyphIdArray

	for(int i=0x0001;i<0xffff;i++){
		if(c2g[i]){
			*(scp++)=B_HOST_TO_BENDIAN_INT16(i);
			*(idp++)=B_HOST_TO_BENDIAN_INT16(c2g[i]-i);
			*(irp++)=B_HOST_TO_BENDIAN_INT16(0);
			for(;i<0xfffe;i++)if(c2g[i+1]==0)break;
			*(ecp++)=B_HOST_TO_BENDIAN_INT16(i);
		}
	}
	//end-mark
	*(scp++)=B_HOST_TO_BENDIAN_INT16(0xffff);
	*(idp++)=B_HOST_TO_BENDIAN_INT16(1);
	*(irp++)=B_HOST_TO_BENDIAN_INT16(0);
	*(ecp++)=B_HOST_TO_BENDIAN_INT16(0xffff);
	return(0);
}

uint16 ttf_cmap::get_gno(uint16 chr)
{
	return(c2g[chr]);
}

uint16 ttf_cmap::get_chr(uint16 gno)
{
	uint16	chr=0xffff;
	for(int i=0x0000;i<0xffff;i++){
		if(c2g[i]==gno){chr=i;break;}
	}
	return(chr);
}

int ttf_cmap::set_chr(uint16 chr_st,uint16 chr_ed,uint16 gno_st)
{
	if(gno_st!=0xffff){
		for(int i=chr_st;i<=chr_ed;i++)c2g[i]=gno_st++;
	}else{
		for(int i=chr_st;i<=chr_ed;i++)c2g[i]=0;
	}
	set_tbl();
	return(0);
}
//------------------------------------------------
ttf_glyf::ttf_glyf(ttf *p,uchar *dat,uint32 size):ttf_table(p,'glyf',dat,size)
{
	BRect	tf,ef;
	tf.Set(0,0,49,511);		tf.OffsetTo(0,0);	//20+33);
	ef.Set(0,0,511,511);	ef.OffsetTo(tf.right+1,0);	//20+33);
	tv=new glyftoolview(tf,this);
	ev=new glyfeditview(ef,this);
	AddChild(tv);
	AddChild(ev);
}

ttf_glyf::~ttf_glyf()
{
}

int ttf_glyf::decode(uint32 off,uint32 len,glyph *gl)
{	//0.ok  -1.not_found  +.err
	if(len==0)return(0);

	uchar	*p=tbl_dat+off;
	int16	noc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
	uint16	xmin=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
	uint16	ymin=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4));
	uint16	xmax=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+6));
	uint16	ymax=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+8));
	p+=10;
	if(noc>=0){	//simple glyph
		uint16	*epoc=new uint16[noc];
		for(int i=0;i<noc;i++){
			epoc[i]=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
			p+=2;
		}
		uint16	ilen=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
		p+=2;
		uchar	*inst=new uchar[ilen];
		for(int i=0;i<ilen;i++){
			inst[i]=*(p++);
		}
		uchar	*flag=new uchar[epoc[noc-1]+1];
		for(int i=0;i<=epoc[noc-1];i++){
			flag[i]=*(p++);
			if(flag[i]&0x08){
				int	r=*(p++);
				for(int j=0;j<r;j++)flag[i+j+1]=flag[i];
				i+=r;
			}
		}
		int16	*dx=new int16[epoc[noc-1]+1];
		for(int i=0;i<=epoc[noc-1];i++){
			uchar	f=flag[i]&0x12;
			if(f==0x00){dx[i]=B_BENDIAN_TO_HOST_INT16(*(int16*)p);p+=2;}
			else if(f==0x02)dx[i]=-*(p++);
			else if(f==0x12)dx[i]=*(p++);
			else dx[i]=0;
		}		
		int16	*dy=new int16[epoc[noc-1]+1];
		for(int i=0;i<=epoc[noc-1];i++){
			uchar	f=flag[i]&0x24;
			if(f==0x00){dy[i]=B_BENDIAN_TO_HOST_INT16(*(int16*)p);p+=2;}
			else if(f==0x04)dy[i]=-*(p++);
			else if(f==0x24)dy[i]=*(p++);
			else dy[i]=0;
		}		

		int	ps=0;
		int	x=0;
		int	y=0;
		for(int in=0;in<noc;in++){
			gl->sh[gl->cnt]=new shape(epoc[in]-ps+1);
			for(int ip=ps;ip<=epoc[in];ip++){
				x+=dx[ip];y+=dy[ip];
				gl->sh[gl->cnt]->set(ip-ps,BPoint(x,y),(flag[ip]&1)?0:1);
			}
			ps=epoc[in]+1;
			gl->sh[gl->cnt]->ctrlp2form();
			gl->cnt++;
		}

		if(epoc)delete epoc;
		if(inst)delete inst;
		if(flag)delete flag;
		if(dx)delete dx;
		if(dy)delete dy;
	}else{	//composite
		for(int ip=0;;ip++){
			uint16	flg=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
			uint16	gno=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
			p+=4;
			int16	arg1,arg2;
			if(flg&0x0001){
				arg1=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
				arg2=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
				p+=4;
			}else{
				arg1=(char)*(p++);
				arg2=(char)*(p++);
			}
			int16	xscale,scale01,scale10,yscale;
			if(flg&0x0008){
				xscale=yscale=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
				scale01=scale10=0;
				p+=2;
			}else if(flg&0x0040){
				xscale=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
				yscale=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
				scale01=scale10=0;
				p+=4;
			}else if(flg&0x0080){
				xscale=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
				scale01=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
				scale10=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4));
				yscale=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+6));
				p+=8;
			}else{
				xscale=yscale=0x4000;
				scale01=scale10=0;
			}

			glyph	*sub=new glyph(gno);
			sub->dep=gl->dep+1;
			if(!pak->get_glyph(gno,sub)){
				gl->add_compo(sub,arg1,arg2,xscale,scale01,scale10,yscale);
			}

			if(!(flg&0x0020)){
				if(flg&0x0100){
					uint16	num=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
					p+=2;
					uchar	*instr=new uchar[num];
					for(int i=0;i<num;i++)instr[i]=*(p++);
					if(instr)delete instr;
				}
				break;
			}
		}
		
		gl->create_composhape();
	}
	return(0);
}

int ttf_glyf::encode(const glyph *gl,uint32 *off,uint32 *len)
{
	uint16	ilen=0;
	uchar	*inst=NULL;
	if(*len){
		uchar	*p=tbl_dat+*off;
		int16	noc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
		p+=10;
		if(noc>=0){
			p+=noc*2;
			ilen=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
			p+=2;
			inst=new uchar[ilen];
			for(int i=0;i<ilen;i++){
				inst[i]=*(p++);
			}
		}
	}

	int16	xmin,ymin,xmax,ymax;
	xmin=ymin=0x7fff;	xmax=ymax=0x8000;

	uchar	*buf=new uchar[0x1000];
	uchar	*p=buf;
	if(gl->gc==0){	//simple glyph
		*((uint16*)(buf+0))=B_HOST_TO_BENDIAN_INT16(gl->cnt);	//noc
		p+=10;
		uint16	epoc=-1;
		for(int i=0;i<gl->cnt;i++){
			epoc+=gl->sh[i]->pts;
			*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(epoc);	//epoc[]
			p+=2;
		}
		*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(ilen);	//ilen
		p+=2;
		for(int i=0;i<ilen;i++)*(p++)=inst[i];					//inst[]
		uchar	*flag=new uchar[epoc+1];
		uchar	*dx=new uchar[(epoc+1)*2];
		uchar	*dy=new uchar[(epoc+1)*2];
		int	flagl,dxl,dyl;
		flagl=dxl=dyl=0;
		BPoint	b(0,0);
		for(int i=0;i<gl->cnt;i++)for(int j=0;j<gl->sh[i]->pts;j++){
			int	x=gl->sh[i]->pt[j].x;
			int	y=gl->sh[i]->pt[j].y;
			if(xmin>x)xmin=x;	if(xmax<x)xmax=x;
			if(ymin>y)ymin=y;	if(ymax<y)ymax=y;
			int	ddx=x-b.x;
			int	ddy=y-b.y;
			uchar	f=gl->sh[i]->pf[j]?0:1;

			if(ddx==0){
				f|=0x10;
			}else if((ddx<0)&&(ddx>-256)){
				f|=0x02;
				dx[dxl++]=-ddx;
			}else if((ddx>0)&&(ddx<256)){
				f|=0x12;
				dx[dxl++]=ddx;
			}else{
				dx[dxl++]=ddx>>8;
				dx[dxl++]=ddx&255;
			}
			if(ddy==0){
				f|=0x20;
			}else if((ddy<0)&&(ddy>-256)){
				f|=0x04;
				dy[dyl++]=-ddy;
			}else if((ddy>0)&&(ddy<256)){
				f|=0x24;
				dy[dyl++]=ddy;
			}else{
				dy[dyl++]=ddy>>8;
				dy[dyl++]=ddy&255;
			}
			flag[flagl++]=f;
			
			b=gl->sh[i]->pt[j];
		}
		for(int i=0;i<flagl;i++)*(p++)=flag[i];					//flag[]
		for(int i=0;i<dxl;i++)*(p++)=dx[i];						//dx[]
		for(int i=0;i<dyl;i++)*(p++)=dy[i];						//dy[]
		delete flag;
		delete dx;
		delete dy;
	}else{			//composite
		*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(-1);		//noc
		BRect	r(gl->bounds());
		xmin=(r.left>-0x8000)?r.left:0x8000;
		ymin=(r.top>-0x8000)?r.top:0x8000;
		xmax=(r.right<0x7fff)?r.right:0x7fff;
		ymax=(r.bottom<0x7fff)?r.bottom:0x7fff;
		p+=10;
		for(int ip=0;ip<gl->gc;ip++){
			uint16	flg=0;
			int16	arg1=gl->ox[ip];
			int16	arg2=gl->oy[ip];
			if((arg1<-0x80)||(arg1>0x7f)||(arg2<-0x80)||(arg2>0x7f))flg|=0x0001;
			uint16	xscale=gl->sc00[ip];
			uint16	scale01=gl->sc01[ip];
			uint16	scale10=gl->sc10[ip];
			uint16	yscale=gl->sc11[ip];
			if((scale01)||(scale10))flg|=0x0080;
			else if(xscale!=yscale)flg|=0x0040;
			else if(xscale!=0x4000)flg|=0x0008;
			if(ip+1<gl->gc)flg|=0x0020;
			*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(flg);
			*((uint16*)(p+2))=B_HOST_TO_BENDIAN_INT16(gl->gl[ip]->gno);
			p+=4;
			if(flg&0x0001){
				*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(arg1);
				*((uint16*)(p+2))=B_HOST_TO_BENDIAN_INT16(arg2);
				p+=4;
			}else{
				*(p++)=arg1;
				*(p++)=arg2;
			}
			if(flg&0x0008){
				*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(xscale);
				p+=2;
			}else if(flg&0x0040){
				*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(xscale);
				*((uint16*)(p+2))=B_HOST_TO_BENDIAN_INT16(yscale);
				p+=4;
			}else if(flg&0x0080){
				*((uint16*)(p+0))=B_HOST_TO_BENDIAN_INT16(xscale);
				*((uint16*)(p+2))=B_HOST_TO_BENDIAN_INT16(scale01);
				*((uint16*)(p+4))=B_HOST_TO_BENDIAN_INT16(scale10);
				*((uint16*)(p+6))=B_HOST_TO_BENDIAN_INT16(yscale);
				p+=8;
			}
		}
	}

	*((uint16*)(buf+2))=B_HOST_TO_BENDIAN_INT16(xmin);	//xmin
	*((uint16*)(buf+4))=B_HOST_TO_BENDIAN_INT16(ymin);	//ymin
	*((uint16*)(buf+6))=B_HOST_TO_BENDIAN_INT16(xmax);	//xmax
	*((uint16*)(buf+8))=B_HOST_TO_BENDIAN_INT16(ymax);	//ymax

	if((p-buf)&1)*(p++)=0;									////
	int		nsize=tbl_size-*len+(p-buf);
	uchar	*nbuf=malloc32(nsize);
	for(int i=0;i<*off;i++)nbuf[i]=tbl_dat[i];
	for(int i=0;i<p-buf;i++)nbuf[*off+i]=buf[i];
	for(int i=0;i<tbl_size-*off-*len;i++)nbuf[*off+(p-buf)+i]=tbl_dat[*off+*len+i];
	if(tbl_dat)delete tbl_dat;
	tbl_dat=nbuf;
	tbl_size=nsize;
	*len=p-buf;

	delete inst;
	delete buf;
	return(0);
}

int ttf_glyf::get_info(uint16 g_no,uint16 *dep,uint16 *els,uint16 *cts,uint16 *pts)
{
	uint32	off,len;
	pak->loca->get_offset(pak->head->is32loca(),g_no,&off,&len);

	if(len==0){
		*dep=0;
		*els=0;
		*cts=0;
		*pts=0;
		return(0);
	}

	uchar	*p=tbl_dat+off;
	int16	noc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
	p+=10;
	if(noc>=0){	//simple glyph
		*dep=0;
		*els=0;
		*cts=noc;
		*pts=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+(noc-1)*2))+1;
	}else{	//composite
		*dep=0;
		*els=0;
		*cts=0;
		*pts=0;
		for(int ip=0;;ip++){
			uint16	flg=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));
			uint16	gno=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
			p+=4;
			if(flg&0x0001)p+=4;else p+=2;
			if(flg&0x0008)p+=2;else if(flg&0x0040)p+=4;else if(flg&0x0080)p+=8;
			uint16	sdep,sels,scts,spts;
			get_info(gno,&sdep,&sels,&scts,&spts);
			(*els)++;
			*dep=(*dep>sdep)?*dep:sdep;
			*cts+=scts;
			*pts+=spts;
			if(!(flg&0x0020))break;
		}
		(*dep)++;
	}
	return(0);
}

int ttf_glyf::get_rect(uint16 g_no,int16 *xmin,int16 *ymin,int16 *xmax,int16 *ymax)
{
	uint32	off,len;
	pak->loca->get_offset(pak->head->is32loca(),g_no,&off,&len);

	if(len==0){
		*xmin=*ymin=0x7fff;
		*xmax=*ymax=0x8000;
		return(0);
	}

	uchar	*p=tbl_dat+off;
	*xmin=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));
	*ymin=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4));
	*xmax=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+6));
	*ymax=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+8));
	return(0);
}
//------------------------------------------------
ttf_head::ttf_head(ttf *p,uchar *dat,uint32 size):ttf_table(p,'head',dat,size)
{
	struct tm	t;
	t.tm_sec=0;
	t.tm_min=0;
	t.tm_hour=0;
	t.tm_mday=1;	//1st
	t.tm_mon=0;		//jan
	t.tm_year=4;	//1904
	t.tm_wday=-1;	//?
	t.tm_yday=0;
	t.tm_isdst=0;
	t1904=mktime(&t);

	if(dat==NULL)create_default();
}

ttf_head::~ttf_head()
{
}

void ttf_head::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	ms=new BMessage('Vchg');
	tc1=new BTextControl(BRect(20,450,200,470),"fontrevision","fontRevision","",ms);
	tc1->SetDivider(120);
	tc1->SetTarget(this);
	AddChild(tc1);

	MakeFocus();
//	redraw();
}

void ttf_head::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	redraw();
}

void ttf_head::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Vchg':{
			char	s[8];
			int i;
			if(sscanf(tc1->Text(),"%x",&i)==1){
				uint32	mse=i;
				sprintf(s,"%08x",mse);
				tc1->SetText(s);
				*(uint32*)(tbl_dat+4)=B_HOST_TO_BENDIAN_INT32(mse);	//fontRevision
			}
			Draw(Bounds());
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_head::redraw()
{
	static const char	tn[17][32]={
		"tableVersionNumber",
		"fontRevision",
		"checkSumAdjustment",
		"magicNumber",
		"flags",
		"unitsPerEm",
		"created",
		"modified",
		"xMin",
		"yMin",
		"xMax",
		"yMax",
		"macStyle",
		"lowestRecPPEM",
		"fontDirectionHint",
		"indexToLocFormat",
		"glyphDataFormat"
	};

	int	x,y;
	x=20;
	for(int i=0;i<17;i++){
		y=i*15+20;
		DrawString(tn[i],BPoint(x,y));
	}

	uchar	*p=tbl_dat;
	x=170;
	for(int i=0;i<17;i++){
		y=i*15+20;
		char	s[40];
		if((i==6)||(i==7)){
			sprintf(s,"%016llx",B_BENDIAN_TO_HOST_INT64(*(uint64*)p));
			time_t		t=t1904+B_BENDIAN_TO_HOST_INT64(*(uint64*)p);
			struct tm	*tt=localtime((time_t*)&t);
			sprintf(s,"%s (%04d/%02d/%02d %02d:%02d:%02d)",s,tt->tm_year+1900,tt->tm_mon+1,tt->tm_mday,tt->tm_hour,tt->tm_min,tt->tm_sec);
			p+=8;
		}else if(i<4){
			sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
			p+=4;
		}else{
			sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
			p+=2;
		}
		DrawString(s,BPoint(x,y));
	}
}

void ttf_head::create_default()
{
	tbl_dat=malloc32(tbl_size=54);

	uchar	*p=tbl_dat;
	*(uint32*)(p+0)=B_HOST_TO_BENDIAN_INT32(0x10000);		//tableVersionNumber
	*(uint32*)(p+4)=B_HOST_TO_BENDIAN_INT32(0);				//fontRevision
	*(uint32*)(p+8)=0;										//checkSumAdjustment
	*(uint32*)(p+12)=B_HOST_TO_BENDIAN_INT32(0x5f0f3cf5);	//magicNumber
	*(uint16*)(p+16)=B_HOST_TO_BENDIAN_INT16(0x01);			//flags
	*(uint16*)(p+18)=B_HOST_TO_BENDIAN_INT16(512);			//unitsPerEm
	*(uint64*)(p+20)=B_HOST_TO_BENDIAN_INT64(0);			//created
	*(uint64*)(p+28)=B_HOST_TO_BENDIAN_INT64(0);			//modified
	*(uint16*)(p+36)=B_HOST_TO_BENDIAN_INT16(0);			//xMin
	*(uint16*)(p+38)=B_HOST_TO_BENDIAN_INT16(0);			//yMin
	*(uint16*)(p+40)=B_HOST_TO_BENDIAN_INT16(511);			//xMax
	*(uint16*)(p+42)=B_HOST_TO_BENDIAN_INT16(511);			//yMax
	*(uint16*)(p+44)=B_HOST_TO_BENDIAN_INT16(0);			//macStyle
	*(uint16*)(p+46)=B_HOST_TO_BENDIAN_INT16(6);			//lowestRecPPEM
	*(uint16*)(p+48)=B_HOST_TO_BENDIAN_INT16(1);			//fontDirectionHint
	*(uint16*)(p+50)=B_HOST_TO_BENDIAN_INT16(1);			//indexToLocFormat
	*(uint16*)(p+52)=B_HOST_TO_BENDIAN_INT16(0);			//glyphDataFormat
}

BRect ttf_head::bounds()
{
	int16	xmin=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+36));
	int16	ymin=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+38));
	int16	xmax=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+40));
	int16	ymax=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+42));
	return(BRect(xmin,ymax,xmax,ymin));
}

bool ttf_head::is32loca()
{
	int16	itlf=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+50));	//indexToLocFormat
	return(itlf==1);
}

uint16 ttf_head::unitsperem()
{
	uint16	upe=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+18));	//unitsPerEm
	return(upe);
}

void ttf_head::update()
{
	uchar	*p=tbl_dat;
	//set time
	time_t	t=time(NULL);
	t=t-t1904;
	if(*(uint64*)(p+20)==0)*(uint64*)(p+20)=B_HOST_TO_BENDIAN_INT64((uint32)t);	//created
	*(uint64*)(p+28)=B_HOST_TO_BENDIAN_INT64((uint32)t);						//modified
}

void ttf_head::setsum(uint32 sum)
{
	*((uint32*)(tbl_dat+8))=0xb1b0afba-sum;							//checkSumAdjustment
}
//------------------------------------------------
ttf_hhea::ttf_hhea(ttf *p,uchar *dat,uint32 size):ttf_table(p,'hhea',dat,size)
{
	if(dat==NULL)create_default();
}

ttf_hhea::~ttf_hhea()
{
}

void ttf_hhea::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	redraw();
}

void ttf_hhea::redraw()
{
	static const char	tn[17][32]={
		"tableVersionNumber",
		"Ascender",
		"Descender",
		"LineGap",
		"advanceWidthMax",
		"minLeftSideBearing",
		"minRightSideBearing",
		"xMaxExtent",
		"caretSlopeRise",
		"caretSlopeRun",
		"reserved",
		"reserved",
		"reserved",
		"reserved",
		"reserved",
		"metricDataFormat",
		"numberOfHMetrics"
	};

	int	x,y;
	x=20;
	for(int i=0;i<17;i++){
		y=i*15+20;
		DrawString(tn[i],BPoint(x,y));
	}

	uchar	*p=tbl_dat;
	x=170;
	for(int i=0;i<17;i++){
		y=i*15+20;
		char	s[16];
		if(i==0){
			sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
			p+=4;
		}else{
			sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
			p+=2;
		}
		DrawString(s,BPoint(x,y));
	}
}

void ttf_hhea::create_default()
{
	int	chrs=pak->ittf->glfs;

	tbl_dat=malloc32(tbl_size=36);

	uchar	*p=tbl_dat;
	*(uint32*)(p+0)=B_HOST_TO_BENDIAN_INT32(0x10000);		//tableVersionNumber
	*(uint16*)(p+4)=B_HOST_TO_BENDIAN_INT16(512);			//Ascender
	*(uint16*)(p+6)=B_HOST_TO_BENDIAN_INT16(0);				//Descender
	*(uint16*)(p+8)=B_HOST_TO_BENDIAN_INT16(0);				//LineGap
	*(uint16*)(p+10)=B_HOST_TO_BENDIAN_INT16(512);			//advanceWidthMax
	*(uint16*)(p+12)=B_HOST_TO_BENDIAN_INT16(0);			//minLeftSideBearing
	*(uint16*)(p+14)=B_HOST_TO_BENDIAN_INT16(0);			//minRightSideBearing
	*(uint16*)(p+16)=B_HOST_TO_BENDIAN_INT16(512);			//xMaxExtent
	*(uint16*)(p+18)=B_HOST_TO_BENDIAN_INT16(1);			//caretSlopeRise
	*(uint16*)(p+20)=B_HOST_TO_BENDIAN_INT16(0);			//caretSlopeRun
	*(uint16*)(p+22)=B_HOST_TO_BENDIAN_INT16(0);			//reserved
	*(uint16*)(p+24)=B_HOST_TO_BENDIAN_INT16(0);			//reserved
	*(uint16*)(p+26)=B_HOST_TO_BENDIAN_INT16(0);			//reserved
	*(uint16*)(p+28)=B_HOST_TO_BENDIAN_INT16(0);			//reserved
	*(uint16*)(p+30)=B_HOST_TO_BENDIAN_INT16(0);			//reserved
	*(uint16*)(p+32)=B_HOST_TO_BENDIAN_INT16(0);			//metricDataFormat
	*(uint16*)(p+34)=B_HOST_TO_BENDIAN_INT16(chrs);			//numberOfHMetrics
}

uint16 ttf_hhea::numhmtx()
{
	uint16	nhmtx=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+34));	//numberOfHMetrics
	return(nhmtx);
}
//------------------------------------------------
ttf_hmtx::ttf_hmtx(ttf *p,uchar *dat,uint32 size):ttf_table(p,'hmtx',dat,size)
{
	gno=0xffff;
	g=NULL;
	if(dat==NULL)create_default();
}

ttf_hmtx::~ttf_hmtx()
{
	if(g)delete g;
}

void ttf_hmtx::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	ms=new BMessage('Bhit');
	pb_set=new BButton(BRect(500,448,540,470),"set","set",ms);
	pb_set->SetTarget(this);
	AddChild(pb_set);

	ms=new BMessage('Vchg');
	tc_st=new BTextControl(BRect(20,450,120,470),"st","st_glyph","",ms);
	tc_st->SetTarget(this);
	AddChild(tc_st);

	ms=new BMessage('Vchg');
	tc_ed=new BTextControl(BRect(140,450,240,470),"ed","ed_glyph","",ms);
	tc_ed->SetTarget(this);
	AddChild(tc_ed);

	ms=new BMessage('Vchg');
	tc_width=new BTextControl(BRect(260,450,360,470),"width","width","",ms);
	tc_width->SetTarget(this);
	AddChild(tc_width);

	ms=new BMessage('Vchg');
	tc_lsb=new BTextControl(BRect(380,450,480,470),"lsb","lsb","",ms);
	tc_lsb->SetTarget(this);
	AddChild(tc_lsb);

	int	upe=pak->head->unitsperem();
	rgb_color	col;

	ms=new BMessage('Smov');
	sl_left=new BSlider(BRect(20,480,240,500),"left",NULL,ms,-upe,upe);
	col.red=0x00;	col.green=0xff;	col.blue=0x00;	col.alpha=0x00;
	sl_left->SetBarColor(col);
	sl_left->SetTarget(this);
	AddChild(sl_left);

	ms=new BMessage('Smov');
	sl_right=new BSlider(BRect(260,480,480,500),"right",NULL,ms,0,upe*2);
	col.red=0x00;	col.green=0xff;	col.blue=0xff;	col.alpha=0x00;
	sl_right->SetBarColor(col);
	sl_right->SetTarget(this);
	AddChild(sl_right);

	MakeFocus();
}

void ttf_hmtx::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);

	FillRect(rect,B_SOLID_LOW);

	float	gpx,gpy,gsz;
	gpx=100;gpy=100;gsz=300;

	SetHighColor(50,50,50);
	StrokeRect(BRect(gpx,gpy,gpx+gsz-1,gpy+gsz-1));

	if((g==NULL)&&(gno!=0xffff)){
		uint16	upe=pak->head->unitsperem();
		g=new glyph(gno);
		pak->get_glyph(gno,g);
		g->trans(BRect(0,upe-1,upe-1,0),BRect(gpx,gpy,gpx+gsz-1,gpy+gsz-1));
	}
	if(g){
		SetHighColor(255,255,255);
		g->draw(this);
		uint16	upm=pak->head->unitsperem();
		float	l,r;
		l=gsz*sl_left->Value()/upm+gpx;
		r=gsz*sl_right->Value()/upm+gpx;
		SetHighColor(0x00,0xff,0x00);
		StrokeLine(BPoint(l,gpy),BPoint(l,gpy+gsz-1));
		SetHighColor(0x00,0xff,0xff);
		StrokeLine(BPoint(r,gpy),BPoint(r,gpy+gsz-1));
	}
}

void ttf_hmtx::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Smov':{
			uint16 l,r;
			int	width,lsb;
			width=lsb=0;
			l=sl_left->Value();
			r=sl_right->Value();
			sscanf(tc_width->Text(),"%x",&width);
			sscanf(tc_lsb->Text(),"%x",&lsb);
			char	s[8];
			if(l!=(uint16)lsb){sprintf(s,"%04x",l);tc_lsb->SetText(s);}
			if((uint16)r!=(uint16)width){sprintf(s,"%04x",(uint16)r);tc_width->SetText(s);}	//
			Invalidate();
		}break;
		case 'Vchg':{
			void	*from;
			int st,ed,width,lsb;
			st=ed=width=lsb=0;
			if(msg->FindPointer("source",&from))break;
			sscanf(tc_st->Text(),"%x",&st);
			sscanf(tc_ed->Text(),"%x",&ed);
			sscanf(tc_width->Text(),"%x",&width);
			sscanf(tc_lsb->Text(),"%x",&lsb);
			if(from==tc_st){
				if(st>=pak->maxp->numglyphs())break;	//error
				gno=st;
				uint16	w;
				int16	l;
				get_mtx(gno,&w,&l);
				width=w;lsb=l;
				if(g){delete g;g=NULL;}
				ed=st;
			}
			char	s[8];
			sprintf(s,"%04x",st);		tc_st->SetText(s);
			sprintf(s,"%04x",ed);		tc_ed->SetText(s);
			sprintf(s,"%04x",width);	tc_width->SetText(s);
			sprintf(s,"%04x",lsb);		tc_lsb->SetText(s);
			sl_left->SetValue(lsb);
			sl_right->SetValue(width);	//
			Invalidate();
		}break;
		case 'Bhit':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			char	s[8];
			int st,ed,width,lsb;
			st=ed=width=lsb=0;
			sscanf(tc_st->Text(),"%x",&st);
			sscanf(tc_ed->Text(),"%x",&ed);
			sscanf(tc_width->Text(),"%x",&width);
			sscanf(tc_lsb->Text(),"%x",&lsb);
			if(from==pb_set){
				if(st>ed)break;		//error
				if(st>=pak->maxp->numglyphs())break;	//error
				for(int i=st;i<=ed;i++)set_mtx(i,width,lsb);
				if(g){delete g;g=NULL;}
				Invalidate();
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_hmtx::create_default()
{
	int	chrs=pak->ittf->glfs;

	tbl_size=chrs*4;
	tbl_dat=malloc32(tbl_size);

	uchar	*p=tbl_dat;
	for(int i=0;i<chrs;i++){
		*(uint16*)(p+0)=B_HOST_TO_BENDIAN_INT16(512);			//width
		*(uint16*)(p+2)=B_HOST_TO_BENDIAN_INT16(0);				//lsb
		p+=4;
	}
}

int ttf_hmtx::get_mtx(uint16 no,uint16 *width,int16 *lsb)
{
	if(no>=pak->maxp->numglyphs())return(1);
	uint16	nhmtx=pak->hhea->numhmtx();
	if(no<=nhmtx){
		*width=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+no*4));
		*lsb=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+no*4+2));
	}else{
		*width=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+(nhmtx-1)*4));
		*lsb=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+nhmtx*2+no*2));
	}
	return(0);
}

int ttf_hmtx::set_mtx(uint16 no,uint16 width,int16 lsb)
{
	if(no>=pak->maxp->numglyphs())return(1);
	uint16	nhmtx=pak->hhea->numhmtx();
	if(no<=nhmtx){
		*(uint16*)(tbl_dat+no*4)=B_HOST_TO_BENDIAN_INT16(width);		//width
		*(uint16*)(tbl_dat+no*4+2)=B_HOST_TO_BENDIAN_INT16(lsb);		//lsb
	}else{
		*(uint16*)(tbl_dat+nhmtx*2+no*2)=B_HOST_TO_BENDIAN_INT16(lsb);	//lsb
	}
	return(0);
}
//------------------------------------------------
ttf_loca::ttf_loca(ttf *p,uchar *dat,uint32 size):ttf_table(p,'loca',dat,size)
{
	if(dat==NULL)create_default();
}

ttf_loca::~ttf_loca()
{
}

void ttf_loca::create_default()
{
	int	chrs=pak->ittf->glfs;

	tbl_size=(chrs+1)*4;
	tbl_dat=malloc32(tbl_size);

	uchar	*p=tbl_dat;
	for(int i=0;i<chrs+1;i++){
		*(uint32*)p=B_HOST_TO_BENDIAN_INT32(0);
		p+=4;
	}
}

int ttf_loca::get_offset(bool f,int no,uint32 *off,uint32 *len)
{	//0.ok  -1.not_found
	if(f){	//32bit
		if(no*4>=tbl_size)return(-1);
		*off=B_BENDIAN_TO_HOST_INT32(*((uint32*)tbl_dat+no));
		no++;
		*len=((no*4<tbl_size)?B_BENDIAN_TO_HOST_INT32(*((uint32*)tbl_dat+no)):tbl_size)-*off;
	}else{	//16bit
		if(no*2>=tbl_size)return(-1);
		*off=B_BENDIAN_TO_HOST_INT16(*((uint16*)tbl_dat+no))*2;
		no++;
		*len=((no*2<tbl_size)?B_BENDIAN_TO_HOST_INT16(*((uint16*)tbl_dat+no))*2:tbl_size)-*off;
	}
	return(0);
}

int ttf_loca::chg_length(bool f,int no,uint32 len)
{	//0.ok  -1.not_found
	if(f){	//32bit
		if(no*4>=tbl_size)return(-1);
		uint32	off=B_BENDIAN_TO_HOST_INT32(*((uint32*)tbl_dat+no));
		no++;
		uint32	old=((no*4<tbl_size)?B_BENDIAN_TO_HOST_INT32(*((uint32*)tbl_dat+no)):tbl_size)-off;
		uint32	d=len-old;
		for(;no*4<tbl_size;no++){
			off=B_BENDIAN_TO_HOST_INT32(*((uint32*)tbl_dat+no));
			if(off==0xffffffff)break;
			*((uint32*)tbl_dat+no)=B_HOST_TO_BENDIAN_INT32(off+d);
		}
	}else{	//16bit
		if(no*2>=tbl_size)return(-1);
		uint16	off=B_BENDIAN_TO_HOST_INT16(*((uint16*)tbl_dat+no));
		no++;
		uint16	old=((no*2<tbl_size)?B_BENDIAN_TO_HOST_INT16(*((uint16*)tbl_dat+no)):tbl_size/2)-off;
		uint16	d=len/2-old;
		for(;no*2<tbl_size;no++){
			off=B_BENDIAN_TO_HOST_INT16(*((uint16*)tbl_dat+no));
			if(off==0xffff)break;
			*((uint16*)tbl_dat+no)=B_HOST_TO_BENDIAN_INT16(off+d);
		}
	}
	return(0);
}
//------------------------------------------------
ttf_maxp::ttf_maxp(ttf *p,uchar *dat,uint32 size):ttf_table(p,'maxp',dat,size)
{
	if(dat==NULL)create_default();
}

ttf_maxp::~ttf_maxp()
{
}

void ttf_maxp::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

/*
	ms=new BMessage('test');
	tc=new tablecontrol(BRect(250,20,480,320),ms,15);
	AddChild(tc);
*/
	ms=new BMessage('Vchg');
	tc1=new BTextControl(BRect(20,450,200,470),"maxstackelements","maxStackElements","",ms);
	tc1->SetDivider(120);
	tc1->SetTarget(this);
	AddChild(tc1);

	MakeFocus();
//	redraw();
}

void ttf_maxp::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	redraw();
}

void ttf_maxp::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Vchg':{
			char	s[8];
			int i;
			if(sscanf(tc1->Text(),"%x",&i)==1){
				uint16	mse=i;
				sprintf(s,"%04x",mse);
				tc1->SetText(s);
				*(uint16*)(tbl_dat+24)=B_HOST_TO_BENDIAN_INT16(mse);	//maxStackElements
			}
			Draw(Bounds());
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_maxp::redraw()
{
	static const char	tn[15][32]={
		"tableVersionNumber",
		"numGlyphs",
		"maxPoints",
		"maxContours",
		"maxCompositePoints",
		"maxCompositeContours",
		"maxZones",
		"maxTwilightPoints",
		"maxStorage",
		"maxFunctionDefs",
		"maxInstructionDefs",
		"maxStackElements",
		"maxSizeOfInstructions",
		"maxComponentElements",
		"maxComponentDepth"
	};

	int	x,y;
	x=20;
	for(int i=0;i<15;i++){
		y=i*15+20;
		DrawString(tn[i],BPoint(x,y));
	}
	uchar	*p=tbl_dat;
	x=170;
	for(int i=0;i<15;i++){
		y=i*15+20;
		char	s[16];
		if(i==0){
			sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
			p+=4;
		}else{
			sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
			p+=2;
		}
		DrawString(s,BPoint(x,y));
	}
}

void ttf_maxp::create_default()
{
	int	chrs=pak->ittf->glfs;

	tbl_dat=malloc32(tbl_size=32);

	uchar	*p=tbl_dat;
	*(uint32*)(p)=B_HOST_TO_BENDIAN_INT32(0x10000);			//tableVersionNumber
	*(uint16*)(p+4)=B_HOST_TO_BENDIAN_INT16(chrs);			//numGlyphs
	*(uint16*)(p+6)=B_HOST_TO_BENDIAN_INT16(0);				//maxPoints
	*(uint16*)(p+8)=B_HOST_TO_BENDIAN_INT16(0);				//maxContours
	*(uint16*)(p+10)=B_HOST_TO_BENDIAN_INT16(0);			//maxCompositePoints
	*(uint16*)(p+12)=B_HOST_TO_BENDIAN_INT16(0);			//maxCompositeContours
	*(uint16*)(p+14)=B_HOST_TO_BENDIAN_INT16(1);			//maxZones
	*(uint16*)(p+16)=B_HOST_TO_BENDIAN_INT16(0);			//maxTwilightPoints
	*(uint16*)(p+18)=B_HOST_TO_BENDIAN_INT16(0);			//maxStorage
	*(uint16*)(p+20)=B_HOST_TO_BENDIAN_INT16(0);			//maxFunctionDefs
	*(uint16*)(p+22)=B_HOST_TO_BENDIAN_INT16(0);			//maxInstructionDefs
	*(uint16*)(p+24)=B_HOST_TO_BENDIAN_INT16(0);			//maxStackElements
	*(uint16*)(p+26)=B_HOST_TO_BENDIAN_INT16(0);			//maxSizeOfInstructions
	*(uint16*)(p+28)=B_HOST_TO_BENDIAN_INT16(0);			//maxComponentElements
	*(uint16*)(p+30)=B_HOST_TO_BENDIAN_INT16(1);			//maxComponentDepth
}

uint16 ttf_maxp::numglyphs()
{
	return(B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+4)));
}

void ttf_maxp::update()
{
	uint16	mp,mc,mcp,mcc,mce,mcd;
	mp=0;	mc=0;	mcp=0;	mcc=0;	mce=0;	mcd=0;
	uint16	cnt=numglyphs();
	for(uint16 i=0;i<cnt;i++){
		uint16	dep,els,cts,pts;
		pak->glyf->get_info(i,&dep,&els,&cts,&pts);
		if(dep){	//composite
			if(mcp<pts)mcp=pts;
			if(mcc<cts)mcc=cts;
			if(mce<els)mce=els;
			if(mcd<dep)mcd=dep;
		}else{
			if(mp<pts)mp=pts;
			if(mc<cts)mc=cts;
		}
	}

	uchar	*p=tbl_dat;
	*(uint16*)(p+6)=B_HOST_TO_BENDIAN_INT16(mp);			//maxPoints
	*(uint16*)(p+8)=B_HOST_TO_BENDIAN_INT16(mc);			//maxContours
	*(uint16*)(p+10)=B_HOST_TO_BENDIAN_INT16(mcp);			//maxCompositePoints
	*(uint16*)(p+12)=B_HOST_TO_BENDIAN_INT16(mcc);			//maxCompositeContours
	*(uint16*)(p+28)=B_HOST_TO_BENDIAN_INT16(mce);			//maxComponentElements
	*(uint16*)(p+30)=B_HOST_TO_BENDIAN_INT16(mcd);			//maxComponentDepth
//if(B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+24))<0x1800)*(uint16*)(p+24)=B_HOST_TO_BENDIAN_INT16(0x1800);			//maxStackElements
}
//------------------------------------------------
ttf_name::ttf_name(ttf *p,uchar *dat,uint32 size):ttf_table(p,'name',dat,size)
{
	if(dat==NULL)create_default();
}

ttf_name::~ttf_name()
{
	//clear attr-list
	BListItem	*t;
	while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}
}

void ttf_name::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	lv=new BListView(BRect(20,20,540,380),"name-list");
	ms=new BMessage('Nsel');
	lv->SetSelectionMessage(ms);
	lv->SetTarget(this);
	lv->SetHighColor(0,0,0);
	lv->SetLowColor(222,222,222);
	lv->SetViewColor(222,222,222);
	AddChild(lv);

	ms=new BMessage('Nadd');
	pb1=new BButton(BRect(20,410,70,430),"add","add",ms);
	pb1->SetTarget(this);
	AddChild(pb1);

	ms=new BMessage('Ndel');
	pb2=new BButton(BRect(100,410,150,430),"del","del",ms);
	pb2->SetTarget(this);
	AddChild(pb2);

	ms=new BMessage('Nset');
	pb3=new BButton(BRect(500,448,540,470),"set","set",ms);
	pb3->SetTarget(this);
	AddChild(pb3);

	ms=new BMessage('Vchg');
	tc1=new BTextControl(BRect(20,450,120,470),"pid","plathomeID","",ms);
	tc1->SetTarget(this);
	AddChild(tc1);

	ms=new BMessage('Vchg');
	tc2=new BTextControl(BRect(140,450,240,470),"eid","encodingID","",ms);
	tc2->SetTarget(this);
	AddChild(tc2);

	ms=new BMessage('Vchg');
	tc3=new BTextControl(BRect(260,450,360,470),"lid","languageID","",ms);
	tc3->SetTarget(this);
	AddChild(tc3);

	ms=new BMessage('Vchg');
	tc4=new BTextControl(BRect(380,450,480,470),"nid","nameID","",ms);
	tc4->SetTarget(this);
	AddChild(tc4);

	ms=new BMessage('Vchg');
	tc5=new BTextControl(BRect(20,480,540,500),"data","DATA","",ms);
	tc5->SetDivider(30);
	tc5->SetTarget(this);
	AddChild(tc5);

	MakeFocus();
	redraw();
}

void ttf_name::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);
}

void ttf_name::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Nsel':{	//select name
			int32	i;
			if(!msg->FindInt32("index",&i)){
				if(i>=0){
					uint16 pid,eid,lid,nid;
					int32	len=256;
					char	str[256];
					get_field(i,&pid,&eid,&lid,&nid,&len,str);
					tc5->SetText(str);
					sprintf(str,"%04x",pid);	tc1->SetText(str);
					sprintf(str,"%04x",eid);	tc2->SetText(str);
					sprintf(str,"%04x",lid);	tc3->SetText(str);
					sprintf(str,"%04x",nid);	tc4->SetText(str);
				}else{
					tc1->SetText("");
					tc2->SetText("");
					tc3->SetText("");
					tc4->SetText("");
					tc5->SetText("");
				}
			}
		}break;
		case 'Nadd':{
			lv->DeselectAll();
		}break;
		case 'Ndel':{
			int	i=lv->CurrentSelection();
			if(i>=0){
				uint16 pid,eid,lid,nid;
				int32	len=256;
				char	str[256];
				get_field(i,&pid,&eid,&lid,&nid,&len,str);
				set_field(pid,eid,lid,nid);		//delete
				redraw();
			}
		}break;
		case 'Nset':{
			int pid,eid,lid,nid;
			pid=eid=lid=nid=0;
			int	rc=0;
			rc+=sscanf(tc1->Text(),"%x",&pid);
			rc+=sscanf(tc2->Text(),"%x",&eid);
			rc+=sscanf(tc3->Text(),"%x",&lid);
			rc+=sscanf(tc4->Text(),"%x",&nid);
			if(rc==4)set_field(pid,eid,lid,nid,tc5->Text());
			redraw();
		}break;
		case 'Vchg':{
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_name::redraw()
{
	//clear attr-list
	BListItem	*t;
	while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}

	int	c=count();
	for(int i=0;i<c;i++){
		uint16 pid,eid,lid,nid;
		int32	len=256;
		char	str[256],s[300];
		get_field(i,&pid,&eid,&lid,&nid,&len,str);
		sprintf(s,"%04x-%04x-%04x-%04x %s",pid,eid,lid,nid,str);
		BStringItem	*si=new BStringItem(s);
		lv->AddItem(si);
	}
}

void ttf_name::create_default()
{
	static const char	cpr[]="(c)unknown";
	static const char	fam[]="noname";
	static const char	sty[]="Regular";
	static const char	crp[]="unknown";
	static const char	nam[]="noname-regular";
	static const char	ver[]="-.--";

	tbl_dat=malloc32(tbl_size=6);

	uchar	*p=tbl_dat;
	*(uint16*)(p+0)=B_HOST_TO_BENDIAN_INT16(0);				//formatSelector
	*(uint16*)(p+2)=B_HOST_TO_BENDIAN_INT16(0);				//numOfNameRecords
	*(uint16*)(p+4)=B_HOST_TO_BENDIAN_INT16(6);				//offsetToStartOfStringStorage

	set_field(0x0001,0x0000,0x0000,0x0000,cpr);
	set_field(0x0001,0x0000,0x0000,0x0001,fam);
	set_field(0x0001,0x0000,0x0000,0x0002,sty);
	set_field(0x0001,0x0000,0x0000,0x0003,crp);
	set_field(0x0001,0x0000,0x0000,0x0004,nam);
	set_field(0x0001,0x0000,0x0000,0x0005,ver);
	set_field(0x0001,0x0000,0x0000,0x0006,nam);
	set_field(0x0003,0x0001,0x0409,0x0000,cpr);
	set_field(0x0003,0x0001,0x0409,0x0001,fam);
	set_field(0x0003,0x0001,0x0409,0x0002,sty);
	set_field(0x0003,0x0001,0x0409,0x0003,crp);
	set_field(0x0003,0x0001,0x0409,0x0004,nam);
	set_field(0x0003,0x0001,0x0409,0x0005,ver);
	set_field(0x0003,0x0001,0x0409,0x0006,nam);
}

int ttf_name::count()
{
	return(B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+2)));
}

int ttf_name::get_field(int no,uint16 *pid,uint16 *eid,uint16 *lid,uint16 *nid,int32 *len,char *str)
{
	uchar	*p=tbl_dat;
	int	nc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));		//numOfNameRecords
	if(no>=nc)return(1);
	int	oo=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4));		//offsetToStartOfStringStorage
	p=tbl_dat+6+no*12;
	*pid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+0));			//plathomeID
	*eid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));			//encodingID
	*lid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4));			//languageID
	*nid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+6));			//nameID
	int32	l=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+8));		//stringLength
	uint16	o=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+10));	//stringOffset
	char	*s=(char*)tbl_dat+oo+o;	//data-string
	int32	stt;
	(*len)--;
	if((*pid==0x0000)&&(*eid==0x0000)&&(*lid==0x0000)){			//???(unicode)
		convert_to_utf8(B_UNICODE_CONVERSION,s,&l,str,len,&stt);
	}else if((*pid==0x0001)&&(*eid==0x0001)&&(*lid==0x000b)){	//mac-japanese(sjis)
		convert_to_utf8(B_SJIS_CONVERSION,s,&l,str,len,&stt);
	}else if((*pid==0x0003)&&(*eid==0x0001)){					//ms(unicode)
		convert_to_utf8(B_UNICODE_CONVERSION,s,&l,str,len,&stt);
	}else{
		if(*len>=l){stt=0;*len=l;}else stt=1;
		memcpy(str,s,*len);
	}
	str[*len]=0;
	return(0);
}

int ttf_name::set_field(uint16 pid,uint16 eid,uint16 lid,uint16 nid,const char *str)
{
	int		nl=6;		//new_buf length
	int		n=0;		//new numOfNameRecords

	uint64	id=(((uint64)pid)<<48)|(((uint64)eid)<<32)|(((uint64)lid)<<16)|((uint64)nid);
	uchar	f=0;		//1..delete  2..insert  3..replace
	int		ino=0;		//insert place no.
	uchar	*p=tbl_dat;
	int	nc=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+2));		//numOfNameRecords
	int	oo=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+4));		//offsetToStartOfStringStorage
	for(int i=0;i<nc;i++){
		p=tbl_dat+6+i*12;
		uint64	tid=B_BENDIAN_TO_HOST_INT64(*(uint64*)(p+0));	//PID,EID,LID,NID
		uint16	tlen=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+8));	//stringLength
		if(tid!=id){nl+=12+tlen;n++;}else f|=1;
		if(tid<id)ino=i+1;
	}

	int32	len,l,stt;
	char	*s=NULL;
	if(str){
		len=strlen(str);
		l=len*2;
		s=new char[l];
		if((pid==0x0000)&&(eid==0x0000)&&(lid==0x0000)){			//???(unicode)
			convert_from_utf8(B_UNICODE_CONVERSION,str,&len,s,&l,&stt);
		}else if((pid==0x0001)&&(eid==0x0001)&&(lid==0x000b)){		//mac-japanese(sjis)
			convert_from_utf8(B_SJIS_CONVERSION,str,&len,s,&l,&stt);
		}else if((pid==0x0003)&&(eid==0x0001)){						//ms(unicode)
			convert_from_utf8(B_UNICODE_CONVERSION,str,&len,s,&l,&stt);
		}else{
			memcpy(s,str,len);	l=len;	stt=0;
		}
		nl+=12+l;	n++;
		f|=2;
	}else{
		l=0;	stt=0;
	}

	uchar	*nbuf=malloc32(nl);
	uchar	*q=nbuf;
	*(uint16*)(q+0)=B_HOST_TO_BENDIAN_INT16(0);				//formatSelector
	*(uint16*)(q+2)=B_HOST_TO_BENDIAN_INT16(n);				//numOfNameRecords
	*(uint16*)(q+4)=B_HOST_TO_BENDIAN_INT16(6+12*n);		//offsetToStartOfStringStorage
	q=nbuf+6;
	p=tbl_dat+6;
	uchar	*pp=tbl_dat+6+12*nc;
	uchar	*qq=nbuf+6+12*n;
	int16	off=0;
	for(int i=0;i<n;i++){
		if(i==ino){
			if(f&1)p+=12;
			if(f&2){
				*(uint64*)(q+0)=B_HOST_TO_BENDIAN_INT64(id);	//PID,EID,LID,NID
				*(uint16*)(q+8)=B_HOST_TO_BENDIAN_INT16(l);		//stringLength
				*(uint16*)(q+10)=B_HOST_TO_BENDIAN_INT16(off);	//stringOffset
				q+=12;
				memcpy(nbuf+6+12*n+off,s,l);
				off+=l;
				continue;
			}
		}
		uint16	ol=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+8));
		uint16	ooff=B_BENDIAN_TO_HOST_INT16(*(uint16*)(p+10));
		*(uint64*)(q+0)=*(uint64*)(p+0);				//PID,EID,LID,NID
		*(uint16*)(q+8)=B_HOST_TO_BENDIAN_INT16(ol);	//stringLength
		*(uint16*)(q+10)=B_HOST_TO_BENDIAN_INT16(off);	//stringOffset
		p+=12;	q+=12;
		memcpy(qq+off,pp+ooff,ol);
		off+=ol;
	}

	if(s)delete	s;

	delete tbl_dat;
	tbl_dat=nbuf;
	tbl_size=nl;
	return(0);
}
//------------------------------------------------
ttf_post::ttf_post(ttf *p,uchar *dat,uint32 size):ttf_table(p,'post',dat,size)
{
	if(dat==NULL)create_default();
}

ttf_post::~ttf_post()
{
}

void ttf_post::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;
	ms=new BMessage('Vchg');
	tc1=new BTextControl(BRect(20,450,200,470),"isFixedPitch","isFixedPitch","",ms);
	tc1->SetDivider(120);
	tc1->SetTarget(this);
	AddChild(tc1);

	MakeFocus();
//	redraw();
}

void ttf_post::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	redraw();
}

void ttf_post::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Vchg':{
			char	s[8];
			int i;
			if(sscanf(tc1->Text(),"%x",&i)==1){
				uint32	mse=i;
				sprintf(s,"%08x",mse);
				tc1->SetText(s);
				*(uint32*)(tbl_dat+12)=B_HOST_TO_BENDIAN_INT32(mse);	//isFixedPitch
			}
			Draw(Bounds());
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_post::redraw()
{
	static const char	tn[9][32]={
		"FormatType",
		"italicAngle",
		"underlinePosition",
		"underlineThickness",
		"isFixedPitch",
		"minMemType42",
		"maxMemType42",
		"minMemType1",
		"maxMemType1"
	};

	int	x,y;
	x=20;
	for(int i=0;i<9;i++){
		y=i*15+20;
		DrawString(tn[i],BPoint(x,y));
	}

	uchar	*p=tbl_dat;
	x=170;
	for(int i=0;i<9;i++){
		y=i*15+20;
		char	s[16];
		if((i<2)||(i>3)){
			sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
			p+=4;
		}else{
			sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
			p+=2;
		}
		DrawString(s,BPoint(x,y));
	}
}

void ttf_post::create_default()
{
	tbl_dat=malloc32(tbl_size=32);

	uchar	*p=tbl_dat;
	*(uint32*)(p+0)=B_HOST_TO_BENDIAN_INT32(0x30000);		//FormatType
	*(uint32*)(p+4)=B_HOST_TO_BENDIAN_INT32(0x140000);		//italicAngle
	*(uint16*)(p+8)=B_HOST_TO_BENDIAN_INT16(0);				//underlinePosition
	*(uint16*)(p+10)=B_HOST_TO_BENDIAN_INT16(20);			//underlineThickness
	*(uint32*)(p+12)=B_HOST_TO_BENDIAN_INT32(0);			//isFixedPitch
	*(uint32*)(p+16)=B_HOST_TO_BENDIAN_INT32(0);			//minMemType42
	*(uint32*)(p+20)=B_HOST_TO_BENDIAN_INT32(0);			//maxMemType42
	*(uint32*)(p+24)=B_HOST_TO_BENDIAN_INT32(0);			//minMemType1
	*(uint32*)(p+28)=B_HOST_TO_BENDIAN_INT32(0);			//maxMemType1
}
//------------------------------------------------
//------------------------------------------------
ttf_gasp::ttf_gasp(ttf *p,uchar *dat,uint32 size):ttf_table(p,'gasp',dat,size)
{
}

ttf_gasp::~ttf_gasp()
{
	BListItem	*t;
	while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}	//clear attr-list
}

void ttf_gasp::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	lv=new BListView(BRect(20,20,280,200),"gasp-list");
	ms=new BMessage('Fsel');
	lv->SetSelectionMessage(ms);
	lv->SetTarget(this);
	lv->SetHighColor(0,0,0);
	lv->SetLowColor(222,222,222);
	lv->SetViewColor(222,222,222);
	AddChild(lv);

	ms=new BMessage('Bhit');
	pb_add=new BButton(BRect(20,410,70,430),"add","add",ms);
	pb_add->SetTarget(this);
	AddChild(pb_add);

	ms=new BMessage('Bhit');
	pb_del=new BButton(BRect(100,410,150,430),"del","del",ms);
	pb_del->SetTarget(this);
	AddChild(pb_del);

	ms=new BMessage('Bhit');
	pb_set=new BButton(BRect(500,448,540,470),"set","set",ms);
	pb_set->SetTarget(this);
	AddChild(pb_set);

	ms=new BMessage('Vchg');
	tc_pt=new BTextControl(BRect(20,450,120,470),"pt","max-pt","",ms);
	tc_pt->SetTarget(this);
	AddChild(tc_pt);

	ms=new BMessage('Vchg');
	cb_gf=new BCheckBox(BRect(140,450,260,470),"gridfit","grid-fitting",ms);
	cb_gf->SetTarget(this);
	AddChild(cb_gf);

	ms=new BMessage('Vchg');
	cb_gr=new BCheckBox(BRect(280,450,400,470),"grayscale","grayscale-rendering",ms);
	cb_gr->SetTarget(this);
	AddChild(cb_gr);

	MakeFocus();
	redraw();
}

void ttf_gasp::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);
}

void ttf_gasp::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Fsel':{	//select flag
			int32	i;
			if(!msg->FindInt32("index",&i)){
				if(i>=0){
					uint16 pt,f;
					char	str[256];
					get_field(i,&pt,&f);
					sprintf(str,"%04x",pt);	tc_pt->SetText(str);
					cb_gf->SetValue(f&0x0001);
					cb_gr->SetValue(f&0x0002);
				}else{
					tc_pt->SetText("");
					cb_gf->SetValue(0);
					cb_gr->SetValue(0);
				}
			}
		}break;
		case 'Bhit':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			if(from==pb_set){
				int	pt,f;
				sscanf(tc_pt->Text(),"%x",&pt);
				f=0;
				if(cb_gf->Value())f|=0x0001;
				if(cb_gr->Value())f|=0x0002;
				set_field(-1,pt,f);
				redraw();
			}else if(from==pb_add){
				lv->DeselectAll();
			}else if(from==pb_del){
				int	i=lv->CurrentSelection();
				if(i>=0){
					set_field(i,0);		//delete
					redraw();
				}
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ttf_gasp::redraw()
{
	BListItem	*t;
	while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}	//clear attr-list

	static char	fm[4][64]={
		"none",
		"Use gridfitting",
		"Use grayscale rendering",
		"Use gridfitting & grayscale rendering"
	};

	int	c=count();
	for(int i=0;i<c;i++){
		uint16 pt,f;
		char	s[64];
		get_field(i,&pt,&f);
		sprintf(s,"- %04x : %s",pt,fm[f]);
		BStringItem	*si=new BStringItem(s);
		lv->AddItem(si);
	}
}

int ttf_gasp::count()
{
	return(B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+2)));
}

int ttf_gasp::get_field(int no,uint16 *pt,uint16 *f)
{
	if(no>=count())return(1);
	*pt=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+4+no*4+0));
	*f=B_BENDIAN_TO_HOST_INT16(*(uint16*)(tbl_dat+4+no*4+2));
	return(0);
}

int ttf_gasp::set_field(int no,uint16 pt,uint16 f)
{
	int	cc=count();
	if(no>=cc)return(1);
	int	flg=0;	//1..delete  2..insert  3..replace
	if(no<0){	//search
		uint16	pp,ff;
		for(no=0;no<cc;no++){
			get_field(no,&pp,&ff);
			if(pp==pt)flg|=1;
			if(pp>=pt)break;
		}
	}else{
		flg|=1;
	}
	if(pt)flg|=2;
	if(flg==0)return(2);

	if(flg==3){	//overwrite
		*(uint16*)(tbl_dat+4+no*4+0)=B_HOST_TO_BENDIAN_INT16(pt);	//rangeMaxPPEM
		*(uint16*)(tbl_dat+4+no*4+2)=B_HOST_TO_BENDIAN_INT16(f);	//rangeGaspBehavior
	}else{		//remake(change size)
		int	c=(flg==1)?cc-1:cc+1;
		int	l=4+c*4;
		uchar	*t=malloc32(l);
		*(uint16*)(t+0)=B_HOST_TO_BENDIAN_INT16(0x0000);		//version
		*(uint16*)(t+2)=B_HOST_TO_BENDIAN_INT16(c);				//numRanges
		int	ii=0;
		for(int i=0;i<c;i++){
			uint16	pp,ff;
			if(i!=no)get_field(ii++,&pp,&ff);
			else if(flg==1){ii++;get_field(ii++,&pp,&ff);}
			else{pp=pt;ff=f;}
			*(uint16*)(t+4+i*4+0)=B_HOST_TO_BENDIAN_INT16(pp);	//rangeMaxPPEM
			*(uint16*)(t+4+i*4+2)=B_HOST_TO_BENDIAN_INT16(ff);	//rangeGaspBehavior
		}
		delete tbl_dat;
		tbl_dat=t;
		tbl_size=l;
	}
	return(0);
}
//------------------------------------------------
ttf_ebdt::ttf_ebdt(ttf *p,uchar *dat,uint32 size):ttf_table(p,'EBDT',dat,size)
{
	BRect	tf,ef;
	tf.Set(0,0,49,511);		tf.OffsetTo(0,0);	//20+33);
	ef.Set(0,0,511,511);	ef.OffsetTo(tf.right+1,0);	//20+33);
	tv=new ebdttoolview(tf,this);
	ev=new ebdteditview(ef,this);
	AddChild(tv);
	AddChild(ev);
}

ttf_ebdt::~ttf_ebdt()
{
}

int ttf_ebdt::decode(uint32 off,uint16 imgfmt,bitmap *bmp)
{
	if((imgfmt!=1)&&(imgfmt!=2)&&(imgfmt!=5)&&(imgfmt!=6)&&(imgfmt!=7))return(1);

	uchar	*p=tbl_dat+off;
	if((imgfmt==1)||(imgfmt==2)||(imgfmt==8)){			//smallMetrics
		bmp->h=*(p+0);	//height
		bmp->w=*(p+1);	//width
		bmp->bx=*(p+2);	//BearingX
		bmp->by=*(p+3);	//BearingY
		bmp->ad=*(p+4);	//Advance
		p+=5;
	}else if((imgfmt==6)||(imgfmt==7)||(imgfmt==9)){	//bigMetrics
		bmp->h=*(p+0);	//height
		bmp->w=*(p+1);	//width
		bmp->bx=*(p+2);	//horiBearingX
		bmp->by=*(p+3);	//horiBearingY
		bmp->ad=*(p+4);	//horiAdvance
		p+=8;
	}

	if(bmp->dat){delete bmp->dat;bmp->dat=NULL;}
	int	l=bmp->w*bmp->h;
	if(l<=0)return(2);
	bmp->dat=new uchar[l];

	uchar	*q=bmp->dat;
	uchar	b=0x80;
	for(int ih=0;ih<bmp->h;ih++){
		if((imgfmt==1)||(imgfmt==6)){	//byte-aligned
			if(b!=0x80){b=0x80;p++;}
		}
		for(int iw=0;iw<bmp->w;iw++){
			*(q++)=(*p&b)?1:0;
			if((b>>=1)==0){b=0x80;p++;}
		}
	}

	return(0);
}

int ttf_ebdt::encode(const bitmap *bmp,uint32 off,uint16 imgfmt)
{
	if((imgfmt!=1)&&(imgfmt!=2)&&(imgfmt!=5)&&(imgfmt!=6)&&(imgfmt!=7))return(1);

	uchar	*p=tbl_dat+off;
	if((imgfmt==1)||(imgfmt==2)||(imgfmt==8)){			//smallMetrics
		p+=5;
	}else if((imgfmt==6)||(imgfmt==7)||(imgfmt==9)){	//bigMetrics
		p+=8;
	}

	int	l;
	if((imgfmt==1)||(imgfmt==6)){	//byte-aligned
		l=(bmp->w+7)/8;
		l*=bmp->h;
	}else{
		l=bmp->w*bmp->h;
		l=(l+7)/8;
	}
	if(l<=0)return(2);
	for(int i=0;i<l;i++)p[i]=0;	//clr

	uchar	*q=bmp->dat;
	uchar	b=0x80;
	for(int ih=0;ih<bmp->h;ih++){
		if((imgfmt==1)||(imgfmt==6)){	//byte-aligned
			if(b!=0x80){b=0x80;p++;}
		}
		for(int iw=0;iw<bmp->w;iw++){
			if(*(q++))*p|=b;
			if((b>>=1)==0){b=0x80;p++;}
		}
	}

	return(0);
}
//------------------------------------------------
ttf_eblc::ttf_eblc(ttf *p,uchar *dat,uint32 size):ttf_table(p,'EBLC',dat,size)
{
}

ttf_eblc::~ttf_eblc()
{
}

void ttf_eblc::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	static const char	tn[33][32]={
		"version",
		"numSizes",
//		"indexSubTableArrayOffset",
//		"indexTablesSize",
//		"numberOfIndexSubTables",
		"colorRef",
		"hori-ascender",
		"hori-descender",
		"hori-widthMax",
		"hori-caretSlopeNumerator",
		"hori-caretSlopeDenominator",
		"hori-caretOffset",
		"hori-minOriginSB",
		"hori-minAdvanceSB",
		"hori-maxBeforeBL",
		"hori-minAfterBL",
		"hori-pad1",
		"hori-pad2",
		"vert-ascender",
		"vert-descender",
		"vert-widthMax",
		"vert-caretSlopeNumerator",
		"vert-caretSlopeDenominator",
		"vert-caretOffset",
		"vert-minOriginSB",
		"vert-minAdvanceSB",
		"vert-maxBeforeBL",
		"vert-minAfterBL",
		"vert-pad1",
		"vert-pad2",
		"startGlyphIndex",
		"endGlyphIndex",
		"ppemX",
		"ppemY",
		"bitDepth",
		"flags"
	};

	int	x,y;
	x=20;
	for(int i=0;i<33;i++){
		y=i*15+20;
		DrawString(tn[i],BPoint(x,y));
	}

	uchar	*p=tbl_dat;

	x=170;
	for(int i=0;i<2;i++){
		y=i*15+20;
		char	s[16];
		sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
		p+=4;
		DrawString(s,BPoint(x,y));
	}

	int	c=B_BENDIAN_TO_HOST_INT32(*(uint32*)(tbl_dat+4));
	for(int j=0;j<c;j++){
		p+=4*3;
		x=170+j*70;
		for(int i=2;i<33;i++){
			y=i*15+20;
			char	s[16];
			if(i==2){
				sprintf(s,"%08x",B_BENDIAN_TO_HOST_INT32(*(uint32*)p));
				p+=4;
			}else if((i==27)||(i==28)){
				sprintf(s,"%04x",B_BENDIAN_TO_HOST_INT16(*(uint16*)p));
				p+=2;
			}else{
				sprintf(s,"%02x",(uchar)*(p++));
			}
			DrawString(s,BPoint(x,y));
		}
	}
}

int ttf_eblc::get_sizes(int *cnt,uchar *ppem)
{
	int	sizes=0;
	int	c=B_BENDIAN_TO_HOST_INT32(*(uint32*)(tbl_dat+4));
	for(int i=0;i<c;i++){
		uchar	*p=tbl_dat+8+i*48;
		uchar	ppemx=*(p+44);
		uchar	ppemy=*(p+45);
		int	j;
		for(j=0;j<sizes;j++){
			if((ppem[j*2]==ppemx)&&(ppem[j*2+1]==ppemy))break;
		}
		if(j==sizes){
			ppem[j*2]=ppemx;ppem[j*2+1]=ppemy;
			sizes++;
		}
	}
	*cnt=sizes;
	return(0);
}

int ttf_eblc::get_offset(bitmap *bmp,uint32 *off,uint16 *imgfmt)
{
	*off=NULL;
	int	c=B_BENDIAN_TO_HOST_INT32(*(uint32*)(tbl_dat+4));
	for(int i=0;i<c;i++){
		uchar	*p=tbl_dat+8+i*48;
		if((*(p+44)!=bmp->ppemx)||(*(p+45)!=bmp->ppemy))continue;	//ppemX,ppemY
		uchar	*pp=tbl_dat+B_BENDIAN_TO_HOST_INT32(*(uint32*)(p+0));	//indexSubTableArrayOffset
		int		cc=B_BENDIAN_TO_HOST_INT32(*(uint32*)(p+8));			//numberOfIndexSubTables
		for(int ii=0;ii<cc;ii++){
			uint16	fg=B_BENDIAN_TO_HOST_INT16(*(uint16*)(pp+ii*8+0));	//firstGlyphIndex
			uint16	lg=B_BENDIAN_TO_HOST_INT16(*(uint16*)(pp+ii*8+2));	//lastGlyphIndex
			int	no=bmp->gno;
			if((no<fg)||(no>lg))continue;
			no-=fg;
			uchar	*ppp=pp+B_BENDIAN_TO_HOST_INT32(*(uint32*)(pp+ii*8+4));	//additionalOffsetToIndexSubtable
			uint16	idf=B_BENDIAN_TO_HOST_INT16(*(uint16*)(ppp+0));	//indexFormat
			uint16	imf=B_BENDIAN_TO_HOST_INT16(*(uint16*)(ppp+2));	//imageFormat
			uint32	ido=B_BENDIAN_TO_HOST_INT32(*(uint32*)(ppp+4));	//imageDataOffset
			*imgfmt=imf;
			if(idf==1){
				*off=ido+B_BENDIAN_TO_HOST_INT32(*(uint32*)(ppp+8+no*4));
			}else if(idf==2){
				*off=ido+no*B_BENDIAN_TO_HOST_INT32(*(uint32*)(ppp+8));
				bmp->h=*(ppp+12);	//height
				bmp->w=*(ppp+13);	//width
				bmp->bx=*(ppp+14);	//BearingX
				bmp->by=*(ppp+15);	//BearingY
				bmp->ad=*(ppp+16);	//Advance
			}else if(idf==3){
				*off=ido+B_BENDIAN_TO_HOST_INT16(*(uint16*)(ppp+8+no*2));
			}else{
				return(2);
			}
			break;
		}
		break;
	}
	if(*off==NULL)return(1);
	return(0);
}
//------------------------------------------------
//------------------------------------------------
glyfeditview::glyfeditview(BRect frame,ttf_glyf *glyf):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	parent=glyf;
	
	canvas=BRect(0,0,0,0);
	kin=0;
	mdf=false;	mcf=true;

	obj=new glyph();
	obje=NULL;	//create now
	
	gno=chr=0xffff;
	psize=0;
}

glyfeditview::~glyfeditview()
{
}

void glyfeditview::AttachedToWindow()
{
	init();
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(0,0,0);
	SetFont(be_bold_font);
SetPenSize(0);
	MakeFocus();
}

void glyfeditview::Draw(BRect rect)
{
	FillRect(canvas,B_SOLID_LOW);
	obj->draw(this);
	obj->drawframe(this,2/scale);
	if(obje)obje->drawframe(this,1);
	if(sel_now.f)drawframe(sel_now.rect);
}

void glyfeditview::KeyDown(const char *bytes,int32 numBytes)
{
	if(kin)return;
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))kin|=0x01;		//up
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))kin|=0x02;		//down
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))kin|=0x04;		//left
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))kin|=0x08;	//right
		if(*bytes=='@')kin|=0x10;								//reverse rotate
		if(*bytes==B_DELETE)kin|=0x80;							//delete
	}
	if((kin)&&(obj->cnt+obj->gc)&&(now_mode==0)){
		if(selm==1){
			if(kin==1){		//to top
				obj->sel_to_top();
			}
			if(kin==2){		//to bottom
				obj->sel_to_bot();
			}
			if(kin==0x10){	//reverse rotate
				obj->rev_sel();
			}
			if(kin==0x80){	//delete
				obj->del_sel();
				selm=0;
				send2toolv(0x08);
			}
		}else{
			if(kin==1){	//select first
				obj->sel_first();
				selm=1;
			}
			if(kin==2){	//select last
				obj->sel_last();
				selm=1;
			}
		}
		if(kin==4){		//select back
			obj->sel_back();
			selm=1;
		}
		if(kin==8){		//select next
			obj->sel_next();
			selm=1;
		}
		redraw(5);
	}
}

void glyfeditview::KeyUp(const char *bytes,int32 numBytes)
{
	kin=0;
}

void glyfeditview::MouseDown(BPoint pt)
{
	chkinput();
}
void glyfeditview::MouseUp(BPoint pt)
{
	chkinput();
}
void glyfeditview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	chkinput();
}

void glyfeditview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'init':{
			gno=0xffff;
			if(obj){delete obj;obj=NULL;}
			obj=new glyph();
			if(obje){delete obje;obje=NULL;}
			chgscale(1);
			Window()->Zoom();
			msg->FindRect("bounds",&canvas);
			canvasok=true;
			init();
			Window()->Zoom();
			Invalidate();
		}break;
		case 'drpi':{
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if(obje)delete obje;obje=NULL;
			obj->sel_none();
			now_mode=0;
			send2toolv(0x80);
		}break;
		case 'drfr':if(obj->gc==0){
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if(obje)delete obje;obje=NULL;
			obj->sel_none();
			now_mode=1;
			send2toolv(0x80);
		}break;
		case 'drre':if(obj->gc==0){
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if(obje)delete obje;obje=NULL;
			obj->sel_none();
			now_mode=2;
			send2toolv(0x80);
		}break;
		case 'drel':if(obj->gc==0){
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if(obje)delete obje;obje=NULL;
			obj->sel_none();
			now_mode=3;
			send2toolv(0x80);
		}break;
		case 'drpo':if(obj->gc==0){
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if(obje)delete obje;obje=NULL;
			obj->sel_none();
			now_mode=4;
			send2toolv(0x80);
		}break;
		case 'drro':if(obj->gc==0){
			redraw(2);	//erase frame
			selm=0;
			sel_now.f=0;
			if(obje)delete obje;obje=NULL;
			obj->sel_none();
			now_mode=5;
			send2toolv(0x80);
		}break;
		case 'edrd':{
			redraw(5);
		}break;
		case 'Cdel':if(gno!=0xffff){
			int8	i8;
			if(msg->FindInt8("no",&i8))break;
			obj->clr_composhape();
			obj->del_compo((uchar)i8);
			obj->create_composhape();
			obj->trans(ettf->bounds(),canvas);
			send2toolv(0x0f);
			redraw(5);
		}break;
		case 'Cadd':if(gno!=0xffff){
			int16	i16;
			if(msg->FindInt16("sub",&i16))break;
			glyph *sub=new glyph((uint16)i16);
			sub->dep=1;
			if(ettf->get_glyph((uint16)i16,sub)){delete sub;break;}
			obj->clr_composhape();
			obj->add_compo(sub);
			obj->create_composhape();
			obj->trans(ettf->bounds(),canvas);
			send2toolv(0x0f);
			redraw(5);
		}break;
		case 'Gclr':if(gno!=0xffff){
			if(obj){delete obj;obj=NULL;}
			obj=new glyph(gno);
			send2toolv(0x0f);
			redraw(5);
		}break;
		case 'Gset':if(gno!=0xffff){
			obj->trans(canvas,ettf->bounds());
			ettf->set_glyph(gno,obj);
			if(obj){delete obj;obj=NULL;}
			obj=new glyph(gno);
			ettf->get_glyph(gno,obj);
			obj->trans(ettf->bounds(),canvas);
			send2toolv(0x0f);
			redraw(5);
		}break;
		case 'Vchg':if(ettf){
			int8	i8;
			int16	i16;
			float	f;
			uint32	chgf=0;
			if(!msg->FindInt16("gno",&i16)){
				gno=(uint16)i16;
				if(gno>=ettf->maxp->numglyphs())gno=0x0000;
				chr=ettf->cmap->get_chr(gno);
				chgf|=0x01;
			}
			if(!msg->FindInt16("chr",&i16)){
				chr=(uint16)i16;
				gno=ettf->cmap->get_gno(chr);
//				if(gno>=ettf->maxp->numglyphs())gno=0x0000;
				chgf|=0x02;
			}
			if(chgf){
				if(obj){delete obj;obj=NULL;}
				obj=new glyph(gno);
				ettf->get_glyph(gno,obj);
				obj->trans(ettf->bounds(),canvas);
				send2toolv(0x0f);
				redraw(5);

				if(obj->gc!=0){
					redraw(2);	//erase frame
					selm=0;
					sel_now.f=0;
					if(obje)delete obje;obje=NULL;
					obj->sel_none();
					now_mode=0;
					send2toolv(0x80);
				}
			}
			if(!msg->FindInt8("psize",&i8)){psize=i8;chgf|=0x10;}
			if(!msg->FindFloat("scale",&f)){chgscale(f);chgf|=0x80;}
		}break;
		case B_COPY:{
			if((obj->cnt+obj->gc)&&(now_mode==0)&&(selm==1)){
				obj->copy();
				redraw(5);
			}
		}break;
		case B_PASTE:{
			if((obj->cnt+obj->gc)&&(now_mode==0)){
				obj->paste();
				redraw(5);
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void glyfeditview::chkinput()
{
	static input	inp_n,inp_b;	//now,before input
	static BPoint	pt_n,pt_b;		//now,before point(view)
	static uchar	bt_n,bt_b;		//now,before button


	BPoint	p;uint32	b;	GetMouse(&p,&b);		//dummy
	SetMouseEventMask(B_POINTER_EVENTS);

	inp_n=((fontedwindow*)Window())->inp;
	pt_n=inp_n.where;
	pt_n=BPoint((int)(pt_n.x/scale),(int)(pt_n.y/scale));
	bt_n=(uchar)inp_n.buttons;
	if(bt_n==B_PRIMARY_MOUSE_BUTTON){
		if(inp_n.modifiers&B_SHIFT_KEY)bt_n=B_SECONDARY_MOUSE_BUTTON;
		if(inp_n.modifiers&B_CONTROL_KEY)bt_n=B_TERTIARY_MOUSE_BUTTON;
		if(inp_n.modifiers&B_COMMAND_KEY)bt_n=B_QUATERNARY_MOUSE_BUTTON;
	}

	if(pt_n!=pt_b){
		ptr_move(pt_n,bt_b,inp_n);
	}
	if(bt_n!=bt_b){
		uchar	bt;
		if(bt=bt_b&~bt_n)btn_up(pt_n,bt,inp_n);
		if(bt=~bt_b&bt_n)btn_down(pt_n,bt,inp_n);
	}
	pt_b=pt_n;
	bt_b=bt_n;
	inp_b=inp_n;
}

void glyfeditview::ptr_move(BPoint pt,uchar bt,input inp)
{
	if(pt==mmp)return;else mmp=pt;
	if((!mdf)&&(!(((now_mode>=4)&&(now_mode<=5))&&(selm<0))))return;
	if(!canvas.Contains(pt))return;
	if(now_mode>0){
		if(selm<0){
			redraw(2);
			obje->create(mdf?PRESSMOVE:RELEASEMOVE,pt,psize);
			redraw(2);
		}
	}else{
		if(selm<0){
			redraw(2);
			sel_now.rect=BRect(mbp,pt);
			redraw(2);
		}
		if(now_mode==0){
			if((selm==2)||(selm==3)){
				redraw(2);
				if((mcf)&&(bt==B_TERTIARY_MOUSE_BUTTON)){
					mcf=false;
					obj->copy_sel(pt-mbp);
				}
				obj->move_sel(pt-mbp);
				mbp=pt;
				redraw(2);
			}
		}
	}
}

void glyfeditview::btn_up(BPoint pt,uchar bt,input inp)
{
	if(!mdf)return;
	mdf=false;	mcf=true;

	if(now_mode>0){
		redraw(2);						//erase-frame
		if(selm<0){
			int	stt=obje->create(RELEASE,pt,psize);
			if(stt==-1){		//created
				shape	**ss=obje->to_shape();
				if(ss){
					for(int i=0;ss[i];i++)obj->add_shape(ss[i]);
					delete ss;
				}
				send2toolv(0x08);
			}
			if(stt<0){selm=0;delete obje;obje=NULL;}
			if(selm)redraw(2);else redraw(5);
		}
	}else{
		if(selm<0){
			if(pt.x<canvas.left)pt.x=canvas.left;
			if(pt.x>canvas.right)pt.x=canvas.right;
			if(pt.y<canvas.top)pt.y=canvas.top;
			if(pt.y>canvas.bottom)pt.y=canvas.bottom;
			if(mbp.x<pt.x){sel_now.rect.left=mbp.x;sel_now.rect.right=pt.x;}else{sel_now.rect.left=pt.x;sel_now.rect.right=mbp.x;}
			if(mbp.y<pt.y){sel_now.rect.top=mbp.y;sel_now.rect.bottom=pt.y;}else{sel_now.rect.top=pt.y;sel_now.rect.bottom=mbp.y;}
		}
		if(now_mode==0){
			if(selm==4)obj->del_sel();
			if(selm==5)obj->tgl_sel();
			sel_now.f=0;
			if(selm<2){
				if(obj->sel_check(sel_now.rect))selm=1;		//selected_mode
				redraw(4);									//
			}else{	//2.move,3.edit,4.delete,5.toggle
				if(obj->gc){								//composite
					obj->clr_composhape();
					obj->create_composhape();
					obj->trans(ettf->bounds(),canvas);
				}
				selm=1;
				redraw(5);									//redraw-all
			}
			obj->sel_check();
			send2toolv(0x08);
		}else{
			selm=1;
		}
	}	
}

void glyfeditview::btn_down(BPoint pt,uchar bt,input inp)
{
	SetMouseEventMask(B_POINTER_EVENTS);
	if(!canvas.Contains(pt))return;
MakeFocus();
	mdf=true;
	mbp=pt;

	if(now_mode>0){
		redraw(2);						//erase-frame
		if(selm==0){
			if(now_mode==1)obje=new obj_free();
			if(now_mode==2)obje=new obj_rect();
			if(now_mode==3)obje=new obj_ellipse();
			if(now_mode==4)obje=new obj_polygon();
			if(now_mode==5)obje=new obj_round();
			selm=-1;		//now create
		}
		int	stt=obje->create(bt==B_SECONDARY_MOUSE_BUTTON?CANSEL:PRESS,pt,psize);
		if(stt==-1){		//created
			shape	**ss=obje->to_shape();
			if(ss){
				for(int i=0;ss[i];i++)obj->add_shape(ss[i]);
				delete ss;
			}
			send2toolv(0x08);
		}
		if(stt<0){selm=0;delete obje;obje=NULL;}
		if(selm)redraw(2);else redraw(5);
	}else if(now_mode==0){
		redraw(2);					//erase-frame
		uchar	scf=obj->sel_check(pt,2/scale);
		if(scf){
			if(scf==1){								//move
				selm=2;
			}else{
				for(int i=0;i<obj->cnt;i++)if(obj->sh[i]->sel_pt<0)obj->sh[i]->sel_pt=0;
				if(bt==B_QUATERNARY_MOUSE_BUTTON){	//toggle-point
					selm=5;
				}else if(bt==B_SECONDARY_MOUSE_BUTTON){	//delete-point
					selm=4;
					send2toolv(0x08);
				}else{								//edit
					selm=3;
				}
			}
			redraw(2);				//draw-frame
		}else{				//now_out_of_selected_object
			if(bt==B_PRIMARY_MOUSE_BUTTON){
				obj->sel_none();
				selm=-1;
			}
			sel_now.f=1;
			sel_now.rect=BRect(pt,pt);
		}
	}	
}

float glyfeditview::getscale()
{
	return(scale);
}

void glyfeditview::chgscale(float sc)
{
	if(sc==0){
		BRect	r=parent->pak->bounds();
		float	z=(r.Width()>r.Height())?r.Width():r.Height();
		for(sc=4;z*sc>512;sc-=.05);
	}
	scale=sc;
	SetScale(sc);
	MoveTo(50,0);
	if(!IsHidden())((fontedwindow*)Window())->settarget(BRect(0,0,0,0),NULL,NULL,(canvas.Width()+1)*sc,(canvas.Height()+1)*sc);
	send2toolv(0x10);
	Invalidate();
}

void glyfeditview::init()
{
	sel_now.f=0;
	selm=0;
	now_mode=0;
	chgscale(0);
	send2toolv(0xff);
}

void glyfeditview::send2toolv(uchar f)
{
	BMessage *mes=new BMessage('Vchg');
	if(f&0x01)mes->AddInt16("gno",gno);
	if(f&0x02)mes->AddInt16("chr",chr);
	if(f&0x04)for(int i=0;i<obj->gc;i++)mes->AddInt16("compo",obj->gl[i]->gno);
	if(f&0x08)mes->AddBool("empty",(obj->cnt==0)&&(obj->gc==0));
	if(f&0x10)mes->AddFloat("scale",scale);
	if(f&0x80)mes->AddInt8("mode",now_mode);
	BMessenger(parent->tv).SendMessage(mes);
}

void glyfeditview::redraw(char f)
{
	if(f&2){
		if(obje)obje->drawframe(this,1);
		obj->drawframe(this,2/scale);	//frame
		if(sel_now.f)drawframe(sel_now.rect);
	}
	if(f&4)Draw(Bounds());										//update screen
}

void glyfeditview::drawframe(BRect r)
{
	r=BRect(r.left*1,r.top*1,r.right*1,r.bottom*1);
	SetDrawingMode(B_OP_INVERT);
	StrokeRect(r,B_MIXED_COLORS);
	SetDrawingMode(B_OP_COPY);
}
//------------------------------------------------
glyftoolview::glyftoolview(BRect frame,ttf_glyf *glyf):BView(frame,"tools",B_FOLLOW_TOP_BOTTOM,B_WILL_DRAW)
{
	parent=glyf;
	
	bm=NULL;
	mode=0;
	psize=0;
	sc=1;
	
	gno=chr=0xffff;
	cps=0;
	emptyf=true;	compof=false;
}

glyftoolview::~glyftoolview()
{
	if(bm)delete bm;
	BListItem	*t;
	while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}	//clear attr-list
}

void glyftoolview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(TOOLVIEWCOLOR>>16),(uchar)(TOOLVIEWCOLOR>>8),(uchar)TOOLVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);

	BMessage	*ms;

	ms=new BMessage('Tchg');
	tc_chr=new BTextControl(BRect(10,10,35,30),"chr","","",ms);
	tc_chr->SetDivider(0);
	tc_chr->SetTarget(this);
	AddChild(tc_chr);
	ms=new BMessage('Tchg');
	tc_cno=new BTextControl(BRect(0,40,45,60),"cno","chr.","0000",ms);
	tc_cno->SetDivider(15);
	tc_cno->SetTarget(this);
	AddChild(tc_cno);
	ms=new BMessage('Tchg');
	tc_gno=new BTextControl(BRect(0,70,45,90),"gno","gno.","0000",ms);
	tc_gno->SetDivider(15);
	tc_gno->SetTarget(this);
	AddChild(tc_gno);

	lv=new BListView(BRect(5,120,45,240),"components");
	lv->SetHighColor(0,0,0);
	lv->SetLowColor(222,222,222);
	lv->SetViewColor(222,222,222);
	lv->Hide();
	AddChild(lv);

	ms=new BMessage('Tchg');
	tc_sub=new BTextControl(BRect(0,260,45,280),"sub","gno.","0000",ms);
	tc_sub->SetDivider(15);
	tc_sub->SetTarget(this);
	tc_sub->Hide();
	AddChild(tc_sub);

	ms=new BMessage('Bhit');
	pb_add=new BButton(BRect(5,300,45,320),"add","add",ms);
	pb_add->SetTarget(this);
	pb_add->Hide();
	AddChild(pb_add);
	ms=new BMessage('Bhit');
	pb_del=new BButton(BRect(5,330,45,350),"del","del",ms);
	pb_del->SetTarget(this);
	pb_del->Hide();
	AddChild(pb_del);

	ms=new BMessage('Bhit');
	pb_csc=new BButton(BRect(5,400,45,420),"clr/simpl/compo","",ms);
	pb_csc->SetTarget(this);
	AddChild(pb_csc);
	ms=new BMessage('Bhit');
	pb_set=new BButton(BRect(5,430,45,450),"set","set",ms);
	pb_set->SetTarget(this);
	AddChild(pb_set);

	redraw();
	MakeFocus();
}

void glyftoolview::Draw(BRect rect)
{
	char	s[8];

	DrawBitmap(bm,BPoint(0,0));

	if(compof)DrawString("composite",BPoint(0,100));

	if((!compof)&&(mode==1)){
		sprintf(s,"%3dpt",psize);
		DrawString(s,BPoint(15,310));
	}

	sprintf(s,"%3d%%",(int)(sc*100));
	DrawString(s,BPoint(15,510));
}

void glyftoolview::MouseDown(BPoint pt)
{
	if((pt.y>10)&&(pt.y<30)){
		if(pt.x<10){gno--;}
		if(pt.x>40){gno++;}
		BMessage *m=new BMessage('Vchg');
		m->AddInt16("gno",(int16)gno);
		BMessenger(parent->ev).SendMessage(m);
		return;
	}
	if((pt.y>300)&&(pt.y<310)){
		if(pt.x<25)psize=(psize<5)?0:psize-5;
		else psize=(psize>95)?100:psize+5;
		BMessage *m=new BMessage('Vchg');
		m->AddInt8("psize",psize);
		BMessenger(parent->ev).SendMessage(m);
		redraw();
		return;
	}
	if(pt.y>500){
		if(pt.x<10){if(sc>.1)sc-=.05;}
		else if(pt.x>40){if(sc<2)sc+=.05;}
		else sc=0;
		BMessage *m=new BMessage('Vchg');
		m->AddFloat("scale",sc);
		BMessenger(parent->ev).SendMessage(m);
		return;
	}

	static uint32	modem[]={'drpi','drfr','drre','drel','drpo','drro'};
	uint32	m=0;
	for(int i=0;i<6;i++){
		if((pt.x>=30)&&(pt.x<=46)&&(pt.y>=i*18+100)&&(pt.y<=i*18+116))m=modem[i];
	}

	if(m){
		BMessenger(parent->ev).SendMessage(m);
	}else{
		BMessage *mes=new BMessage('Vchg');
		mes->AddInt16("gno",gno+1);
		BMessenger(parent->ev).SendMessage(mes);
	}
}

void glyftoolview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			bool	b;
			int8	i8;
			int16	i16;
			float	f;
			if(!msg->FindInt8("mode",&i8))mode=i8;
			if(!msg->FindInt16("gno",&i16)){gno=(uint16)i16;cps=0;compof=false;}
			if(!msg->FindInt16("chr",&i16))chr=(uint16)i16;
			while(!msg->FindInt16("compo",cps,&i16)){compo[cps++]=(uint16)i16;compof=true;}
			if(!msg->FindBool("empty",&b))emptyf=b;
			if(!msg->FindFloat("scale",&f))sc=f;
			redraw();
		}break;
		case 'Tchg':{
			void	*from;
			int		d=0;
			if(msg->FindPointer("source",&from))break;
			if(from==tc_chr){
				//utf8 > unicode
				uchar	*s=(uchar*)tc_chr->Text();
				if(s[0]<0x80)d=s[0];
				else if(s[0]<0xe0)d=((s[0]&0x1f)<<6)|(s[1]&0x3f);
				else d=((s[0]&0x0f)<<12)|((s[1]&0x3f)<<6)|(s[2]&0x3f);
				BMessage *m=new BMessage('Vchg');
				m->AddInt16("chr",(int16)d);
				BMessenger(parent->ev).SendMessage(m);
			}else if(from==tc_gno){
				sscanf(tc_gno->Text(),"%x",&d);
				BMessage *m=new BMessage('Vchg');
				m->AddInt16("gno",(int16)d);
				BMessenger(parent->ev).SendMessage(m);
			}else if(from==tc_cno){
				sscanf(tc_cno->Text(),"%x",&d);
				BMessage *m=new BMessage('Vchg');
				m->AddInt16("chr",(int16)d);
				BMessenger(parent->ev).SendMessage(m);
			}
		}break;
		case 'Bhit':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			if(from==pb_del){
				int		i=lv->CurrentSelection();
				if(i>=0){
					BMessage *m=new BMessage('Cdel');
					m->AddInt8("no",(int8)i);
					BMessenger(parent->ev).SendMessage(m);
				}
			}else if(from==pb_add){
				int		i=0xffff;
				sscanf(tc_sub->Text(),"%x",&i);
				BMessage *m=new BMessage('Cadd');
				m->AddInt16("sub",(int16)i);
				BMessenger(parent->ev).SendMessage(m);
			}else if(from==pb_set){
				BMessage *m=new BMessage('Gset');
				BMessenger(parent->ev).SendMessage(m);
			}else if(from==pb_csc){
				if(emptyf){
					compof=!compof;
					BMessenger(parent->ev).SendMessage('drpi');
				}else{
					BMessenger(parent->ev).SendMessage('Gclr');
					emptyf=true;		/////need not
				}
				cps=0;
				redraw();
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void glyftoolview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(TOOLVIEWCOLOR);

	uint32	tc=B_HOST_TO_LENDIAN_INT32(0xcc0000);
	int	x,y;
	x=2;	y=15;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[2][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=40;	y=15;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[3][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	if((!compof)&&(mode==1)){
		x=1;	y=300;
		for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
			if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
		}
		x=41;	y=300;
		for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
			if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
		}
	}
	x=1;	y=500;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[1][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}
	x=41;	y=500;
	for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
		if(triangle[0][yy]&(1<<xx))*(p+(y+yy)*dy+(x+xx))=tc;
	}

	if(compof){
		BListItem	*t;
		while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}	//clear attr-list
		for(int i=0;i<cps;i++){
			char	s[8];
			sprintf(s,"%04x",compo[i]);
			BStringItem	*si=new BStringItem(s);
			lv->AddItem(si);
		}
		if(!IsHidden()){
			while(lv->IsHidden())lv->Show();
			while(tc_sub->IsHidden())tc_sub->Show();
			while(pb_del->IsHidden())pb_del->Show();
			while(pb_add->IsHidden())pb_add->Show();
		}
	}else{
		if(!IsHidden()){
			while(!lv->IsHidden())lv->Hide();
			while(!tc_sub->IsHidden())tc_sub->Hide();
			while(!pb_del->IsHidden())pb_del->Hide();
			while(!pb_add->IsHidden())pb_add->Hide();
		}
		for(int i=0;i<6;i++){
			uint32	fc,bc;
			if(i==mode){fc=0xffffffff;bc=0x00000000;}else{fc=0x00000000;bc=0xffffffff;}
			int	x=30;
			int	y=i*18+100;
			for(int yy=0;yy<16;yy++)for(int xx=0;xx<16;xx++){
				*(p+(y+yy)*dy+(x+xx))=(iconpat[i][yy]&(0x8000>>xx))?fc:bc;
			}
		}
	}

	char	s[16];
	//unicode > utf8
	if(chr==0xffff)s[0]=0;
	else if(chr<0x80){s[0]=chr;s[1]=0;}
	else if(chr<0x800){s[0]=(chr>>6)|0xc0;s[1]=(chr&0x3f)|0x80;s[2]=0;}
	else{s[0]=(chr>>12)|0xe0;s[1]=((chr>>6)&0x3f)|0x80;s[2]=(chr&0x3f)|0x80;s[3]=0;}
	tc_chr->SetText(s);
	sprintf(s,"%04x",chr);
	tc_cno->SetText(s);
	sprintf(s,"%04x",gno);
	tc_gno->SetText(s);
	if(!emptyf)pb_csc->SetLabel("clr");
	else if(compof)pb_csc->SetLabel("simple");
	else pb_csc->SetLabel("compo");

	Draw(Bounds());
}
//------------------------------------------------
ebdteditview::ebdteditview(BRect frame,ttf_ebdt *ebdt):BView(frame,"canvas",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	parent=ebdt;
	bmp=NULL;
	g=NULL;
	gno=chr=0xffff;
	pt=0;
}

ebdteditview::~ebdteditview()
{
	if(g)delete g;
}

void ebdteditview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(50,50,50);
	SetLowColor(0,0,0);
	SetFont(be_bold_font);
SetPenSize(0);
	MakeFocus();
}

void ebdteditview::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);

	float	gpx,gpy,gsz;
	gpx=100;gpy=100;gsz=300;
	SetHighColor(50,50,50);
	StrokeRect(BRect(gpx,gpy,gpx+gsz-1,gpy+gsz-1));

	if(bmp)bmp->draw(this);

	if((g==NULL)&&(gno!=0xffff)){
		uint16	upe=parent->pak->head->unitsperem();
		g=new glyph(gno);
		parent->pak->get_glyph(gno,g);
		g->trans(BRect(0,upe-1,upe-1,0),BRect(gpx,gpy,gpx+gsz-1,gpy+gsz-1));
	}
	if(g){
MovePenTo(0,0);
		g->draw(this,0xff0000);
		uint16	width;
		int16	lsb;
		parent->pak->hmtx->get_mtx(gno,&width,&lsb);
		uint16	upm=parent->pak->head->unitsperem();
		float	l,r;
		l=gsz*lsb/upm+gpx;
		r=gsz*width/upm+gpx;	//
		SetHighColor(0x00,0xbf,0x00);
		StrokeLine(BPoint(l,gpy),BPoint(l,gpy+gsz-1),B_MIXED_COLORS);
		SetHighColor(0x00,0xbf,0xbf);
		StrokeLine(BPoint(r,gpy),BPoint(r,gpy+gsz-1),B_MIXED_COLORS);
	}

	if(bmp)if(bmp->dat){
		float	l,r;
		l=gsz*bmp->bx/bmp->ppemx+gpx;
		r=gsz*bmp->ad/bmp->ppemx+gpx;
		SetHighColor(0x00,0xff,0x00);
		StrokeLine(BPoint(l,gpy),BPoint(l,gpy+gsz-1));
		SetHighColor(0x00,0xff,0xff);
		StrokeLine(BPoint(r,gpy),BPoint(r,gpy+gsz-1));
	}
}

void ebdteditview::MouseDown(BPoint pt)
{
	if(!bmp->create(PRESS,pt))redraw(7);
}

void ebdteditview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Gset':if(gno!=0xffff){
			ettf->set_bitmap(bmp);
			if(bmp){delete bmp;bmp=NULL;}
			bmp=new bitmap(gno,(uint16)pt>>8,(uchar)pt,1);
			ettf->get_bitmap(bmp);
			bmp->setvrect(BRect(100,100,399,399));
			send2toolv(0x0f);
			redraw(5);
		}break;
		case 'Vchg':{
			int16	i16;
			float	f;
			uint32	chgf=0;
			if(!msg->FindInt16("gno",&i16)){
				gno=(uint16)i16;
				if(gno>=ettf->maxp->numglyphs())gno=0x0000;
				chr=ettf->cmap->get_chr(gno);
				chgf|=0x01;
			}
			if(!msg->FindInt16("chr",&i16)){
				chr=(uint16)i16;
				gno=ettf->cmap->get_gno(chr);
//				if(gno>=ettf->maxp->numglyphs())gno=0x0000;
				chgf|=0x01;
			}
			if(!msg->FindInt16("pt",&i16)){
				pt=(uint16)i16;
				chgf|=0x01;
			}
			if(chgf){
				if(bmp){delete bmp;bmp=NULL;}
				bmp=new bitmap(gno,(uint16)pt>>8,(uchar)pt,1);
				ettf->get_bitmap(bmp);
				bmp->setvrect(BRect(100,100,399,399));
				send2toolv(0x0f);
				if(g){delete g;g=NULL;}
				redraw(5);
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ebdteditview::send2toolv(uchar f)
{
	BMessage *mes=new BMessage('Vchg');
	if(f&0x01)mes->AddInt16("gno",gno);
	if(f&0x02)mes->AddInt16("chr",chr);
	if(f&0x04)mes->AddInt16("pt",pt);
	BMessenger(parent->tv).SendMessage(mes);
}

void ebdteditview::redraw(char f)
{
	if(f&4)Draw(Bounds());										//update screen
}
//------------------------------------------------
ebdttoolview::ebdttoolview(BRect frame,ttf_ebdt *ebdt):BView(frame,"tools",B_FOLLOW_TOP_BOTTOM,B_WILL_DRAW)
{
	parent=ebdt;
	bm=NULL;
	
	gno=chr=0xffff;
	pt=0;
	mf=NULL;	//popupmenu
}

ebdttoolview::~ebdttoolview()
{
	if(bm)delete bm;
}

void ebdttoolview::AttachedToWindow()
{
	SetLowColor(200,200,0);
	SetViewColor((uchar)(TOOLVIEWCOLOR>>16),(uchar)(TOOLVIEWCOLOR>>8),(uchar)TOOLVIEWCOLOR);
	SetFont(be_plain_font);
	SetFontSize(10);
	if(!bm)bm=new BBitmap(Bounds(),B_RGB_32_BIT);

	BMessage	*ms;

	ms=new BMessage('Tchg');
	tc_chr=new BTextControl(BRect(0,10,45,30),"chr","chr.","0000",ms);
	tc_chr->SetDivider(15);
	tc_chr->SetTarget(this);
	AddChild(tc_chr);
	ms=new BMessage('Tchg');
	tc_gno=new BTextControl(BRect(0,40,45,60),"gno","gno.","0000",ms);
	tc_gno->SetDivider(15);
	tc_gno->SetTarget(this);
	AddChild(tc_gno);

	ms=new BMessage('Bhit');
	pb_set=new BButton(BRect(5,430,45,450),"set","set",ms);
	pb_set->SetTarget(this);
	AddChild(pb_set);

	redraw();
	MakeFocus();
}

void ebdttoolview::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
	if(mf)DrawString("point",BPoint(5,80));
}

void ebdttoolview::MouseDown(BPoint pt)
{
	BMessage *mes=new BMessage('Vchg');
	mes->AddInt16("gno",gno+1);
	BMessenger(parent->ev).SendMessage(mes);
}

void ebdttoolview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Vchg':{
			int16	i16;
			if(!msg->FindInt16("gno",&i16))gno=(uint16)i16;
			if(!msg->FindInt16("chr",&i16))chr=(uint16)i16;
			if(!msg->FindInt16("pt",&i16))pt=(uint16)i16;
			redraw();
		}break;
		case 'Tchg':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			if(from==tc_gno){
				int	gno;
				sscanf(tc_gno->Text(),"%x",&gno);
				BMessage *m=new BMessage('Vchg');
				m->AddInt16("gno",(int16)gno);
				BMessenger(parent->ev).SendMessage(m);
			}else if(from==tc_chr){
				int		d=0;
				sscanf(tc_chr->Text(),"%x",&d);
				BMessage *m=new BMessage('Vchg');
				m->AddInt16("chr",(int16)d);
				BMessenger(parent->ev).SendMessage(m);
			}
		}break;
		case 'Msel':{
			int16	i16;
			if(!msg->FindInt16("pt",&i16)){
				BMessage	*m=new BMessage('Vchg');
				m->AddInt16("pt",i16);
				BMessenger(parent->ev).SendMessage(m);
			}
		}break;
		case 'Bhit':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			if(from==pb_set){
				BMessage *m=new BMessage('Gset');
				BMessenger(parent->ev).SendMessage(m);
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void ebdttoolview::init()
{
	int	c=8;
	uchar	*ppem=new uchar[c*2];
	parent->pak->eblc->get_sizes(&c,ppem);

	if(mf){RemoveChild(mf);delete mf;}

	BPopUpMenu	*pm=new BPopUpMenu("pt");
	for(int i=0;i<c;i++){
		BMessage	*ms=new BMessage('Msel');
		ms->AddInt16("pt",(ppem[i*2]<<8)|ppem[i*2+1]);
		char	s[8];
		sprintf(s,"%d",ppem[i*2+1]);	//ppemY
		BMenuItem	*mi=new BMenuItem(s,ms);
		mi->SetTarget(this);
		pm->AddItem(mi);
	}

	mf=new BMenuField(BRect(5,85,45,105),"point",NULL,pm,true,B_FOLLOW_NONE,B_WILL_DRAW);
	AddChild(mf);
	
	delete ppem;
}

void ebdttoolview::redraw()
{
	uint32	*p=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*pp=p;
	int		l=bm->BitsLength()/4;
	while(l--)*(pp++)=B_HOST_TO_LENDIAN_INT32(TOOLVIEWCOLOR);
	char	s[16];
	sprintf(s,"%04x",gno);	tc_gno->SetText(s);
	sprintf(s,"%04x",chr);	tc_chr->SetText(s);
	Draw(Bounds());
}
//------------------------------------------------
initview::initview(BRect frame):BView(BRect(0,0,561,511),"initview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	ettf->ittf=new inittf;
}

initview::~initview()
{
}

void initview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	ms=new BMessage('Bhit');
	pb_set=new BButton(BRect(500,485,540,510),"set","set",ms);
	pb_set->SetTarget(this);
	AddChild(pb_set);
	for(int i=0;i<71;i++){
		ms=new BMessage('Bchk');
		int	x,y;
		x=i/24;	y=i%24;
		cb[i]=new BCheckBox(BRect(x*200,y*20+10,x*200+160,y*20+25),"unicode",uni_blk[i].n,ms);
		cb[i]->SetTarget(this);
		AddChild(cb[i]);
	}

	MakeFocus();
	setchrs();
	redraw();
}

void initview::Draw(BRect rect)
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetViewColor(0,0,0);
	FillRect(rect,B_SOLID_LOW);
	redraw();
}

void initview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'Bhit':{
			BMessenger(be_app).SendMessage('cfge');
		}break;
		case 'Bchk':{
			setchrs();
			redraw();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void initview::redraw()
{
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);

	char	s[32];
	sprintf(s,"%04xchrs.",ettf->ittf->chrs);
	FillRect(BRect(400,480,560,510),B_SOLID_LOW);
	DrawString(s,BPoint(400,508));
}

void initview::setchrs()
{
	for(int j=0;j<128;j++)ettf->ittf->ub[j]=false;
	ettf->ittf->c[0]=true;for(int i=1;i<0x10000;i++)ettf->ittf->c[i]=false;
	for(int j=0;j<71;j++)if(cb[j]->Value()){
		ettf->ittf->ub[j]=true;
		for(int i=uni_blk[j].st;i<=uni_blk[j].ed;i++)ettf->ittf->c[i]=true;
		if(j==69)ettf->ittf->c[0xfeff]=true;	//b69(SPECIALS)
	}
	ettf->ittf->chrs=0;
	for(int i=0;i<0x10000;i++)if(ettf->ittf->c[i])ettf->ittf->chrs++;
	ettf->ittf->glfs=ettf->ittf->chrs;
}
//------------------------------------------------
